//#define DEBUG
//#define ACTION
#include <stdio.h>
#include <stdlib.h>

#define CRLF "<BR>\n"
#include <bnMakro.h>
#include <bnSQL.h>
#include <bnMemInfo.h>

#include <tds.h>
#include <tdsconvert.h>

#include "DEFMsSQL.h"


//2do	mv 2 local var........................................................
char			*Error = NULL;
char			*fetchBuffer = NULL;
static TDSLOGIN		*login;
static TDSSOCKET	*tds;
TDSCONTEXT		*context = NULL;


extern "C" {

    char	*DEF2COL	( _bnColumn  *co, _DEF2COL *DEG2Global );
    _bnColumn	*coInsertX	( _bnTable *tb, _DEF2COL *DEF2Global, char *Name, long Type, long Size, long Flags );


char	*dbClose ( _bnDataBase *db );


static int tsql_handle_message ( const TDSCONTEXT * context, TDSSOCKET * tds, TDSMESSAGE * msg ) {

    if ( ! Error ) { fprintf ( stderr, "! Error" ); return 0; }

    if ( msg->msgno == 5703 ) return 0;//[05703]Changed language setting to us_english.
    if ( msg->msgno == 5701 ) return 0;//[05701]Der Datenbankkontext wurde auf 'master' gendert.
//if ( msg->msgno == 2403 ) return 0;//char convert ...

    //msg->msgno == 20018
    //TDS_CHAR *server;
    //TDS_CHAR *message;
    //TDS_CHAR *proc_name;
    //TDS_CHAR *sql_state;
    //TDS_UINT msgno;
    //TDS_INT line_number;
    //TDS_SMALLINT state;
    //TDS_TINYINT priv_msg_type;
    //TDS_TINYINT severity;
    //int oserr;
    sprintf ( Error, "%s[%05ld]%s\n", Error,msg->msgno, msg->message );
    //puts ( Error );
    //2dofprintf(stderr, "Msg %d, Level %d, State %d, Server %s, Line %d\n%s\n", msg->msgno, msg->severity, msg->state, msg->server, msg->line_number, msg->message );

    if ( msg->msgno == 0 ) return 0;

    return TDS_INT_CANCEL;

}//static int tsql_handle_message(const TDSCONTEXT * context, TDSSOCKET * tds, TDSMESSAGE * msg)


int	clock_gettime ( clockid_t, timespec* ) {//2do ?! seg fault via -lrt
PFL
    exit(1);
};//int	clock_gettime ( clockid_t, timespec* )


char 	*dbOpen ( _bnDataBase *db ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

    Error = db->Error;
    if ( Error[0] ) return Error;

//pg Defaults
    db->Quote	= ' ';			//use " in SQL

    if ( db->Conn ) return Error;

#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, db->Base			);
	printf ( "@%s"		, db->Host			);
	//printf ( " Login=%s"	, db->User			);
	//printf ( "/Passwd=%s"	, db->Pass			);
	printf ( "\n" );
	fflush  ( stdout );
#endif

//login 2 database
    login = tds_alloc_login ();	if ( ! login ) SER ( "! login" );

    tds_set_server		( login, db->Host	);
    //                      done via USE db->Base
    tds_set_user		( login, db->User	);
    tds_set_passwd		( login, db->Pass	);
    //tds_set_client_charset	( login, "ISO-8859-1"	);
    tds_set_client_charset	( login, "UTF-8"	);
    //tds_set_language		( login, "us_english"	);
    //tds_set_library		( login, "TDS-Library"	);

    context		 = tds_alloc_context ( NULL );
    context->msg_handler = tsql_handle_message;
    context->err_handler = tsql_handle_message;
    free ( context->locale->date_fmt );

    //ntext->locale->date_fmt = strdup ( "%d.%m.%Y %H:%M:%S.%z"	);//2do
    context->locale->date_fmt = strdup ( "%Y-%m-%d %H:%M:%S.%z"	);

    tds = tds_alloc_socket ( context, 512 );
    tds_set_parent ( tds, NULL );

TDSCONNECTION *connection = tds_read_config_info ( NULL, login, context->locale );
    if ( ! connection ) SER ( "! connection" );
int ret = tds_connect ( tds, connection );
    SIER ( Error );
    if ( ret == TDS_FAIL ) SER ( "ret == TDS_FAIL" );
    tds_free_connection( connection );

char	sqlcmd[255];
    sprintf ( sqlcmd, "USE %s", db->Base );
    ret = tds_submit_query   ( tds, sqlcmd );
    if ( ret != TDS_SUCCEED ) SER2 ( "TDS_SUCCEED != %ld", ret );
    SIER ( Error );
int result_type;
    ret = tds_process_tokens ( tds, &result_type, NULL, TDS_TOKEN_RESULTS );
    if ( ret != TDS_SUCCEED ) SER2 ( "TDS_SUCCEED != %ld", ret );
    SIER ( Error );

    db->Conn = &tds;

//all OK
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return db->Error;

}//char 	*dbOpen ( _bnDataBase *db )


char	*dbClose ( _bnDataBase *db ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

    Error = db->Error;

//close aktiv conn
    if ( ! db->Conn ) return Error;

#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, db->Base			);
	printf ( "@%s"		, db->Host			);
	//printf ( " Login=%s"	, db->User			);
	//printf ( "/Passwd=%s"	, db->Pass			);
	printf ( "\n" );
	fflush  ( stdout );
#endif

    tds_free_socket	( tds );
    tds_free_login	( login );
    tds_free_context	( context );
    context = NULL;
    db->Conn = NULL;

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return Error;

}//char	*dbClose ( _bnDataBase *db )


char	*tbOpen		( _bnTable *tb ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

    Error = tb->Error;
    if ( tb->Result		) return tb->Error;
    if ( ! tb->SQLQuery		) SER ( "! tb->SQLQuery"	);
    if ( ! tb->SQLQuery[0]	) SER ( "! tb->SQLQuery[0]"	);

#ifdef ACTION
    printf ( "%s"			, (char *)__PRETTY_FUNCTION__	);
    printf ( "		%s"	, (char *)__FILE__		);
    printf ( "	%s"		, tb->Name			);
    printf ( "\n" );
    printf ( "SQL=~%s~\n"		, tb->SQLQuery );
    fflush  ( stdout );
#endif

int		ret;
CONV_RESULT	cr;
int		result_type = 0;
int		done_flags;

    ret = tds_submit_query   ( tds, tb->SQLQuery ); if ( ret != TDS_SUCCEED ) SER2 ( "TDS_SUCCEED != %ld", ret );
    SIER ( Error );

    ret = tds_process_tokens ( tds, &result_type, NULL, TDS_TOKEN_RESULTS ); if ( ret != TDS_SUCCEED ) SER2 ( "TDS_SUCCEED != %ld", ret );
    SIER ( Error );
    if ( result_type != 4049 ) return Error;	//! SELECT
    if ( result_type != TDS_ROWFMT_RESULT ) SER ( "expected row fmt()" );

    ret = tds_process_tokens ( tds, &result_type, NULL, TDS_TOKEN_RESULTS ); if ( ret != TDS_SUCCEED ) SER2 ( "TDS_SUCCEED != %ld", ret );
    SIER ( Error );
    if ( result_type != TDS_ROW_RESULT ) return Error;

//fetch in first record
    ret = tds_process_tokens ( tds, &result_type, NULL, TDS_RETURN_ROW ); if ( ret != TDS_SUCCEED ) SER2 ( "TDS_SUCCEED != %ld", ret );
    SIER ( Error );
    if ( ret != TDS_NO_MORE_RESULTS && ret != TDS_SUCCEED) SER ( "tds_process_tokens() unexpected return" );

//2do reconnect if error
    tb->Result = (void *)&tb->Records;//2do, use cursor

//error check
    if ( Error[0] ) return Error;

//amount of Records
    tb->Records = -1;
    tb->Fokus   =  0;
//amount of Fields
    tb->Fields  = tds->current_results->num_cols;

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return tb->Error;

}//char	*tbOpen		( _bnTable *tb )


_bnColumn	*tbColumnInsert	( _bnTable *tb ) {
PFLID

TDSCOLUMN *curcol = tds->current_results->columns[tb->ColumnInsertFokus];
    //printf ( "curcol->column_type=%05ld curcol->column_size=%05ld conv_type=%05s\n", curcol->column_type, curcol->column_size, curcol->column_name );

char	*myName = curcol->column_name;
long	 myType = curcol->column_type;
long	 mySize = curcol->column_size;
long	 myFlags = 0;

//Flags Mapping
    //if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_PRI_KEY;
    //if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_AUTO_INCREMENT;

    return    coInsertX	( tb, (_DEF2COL *)&MsSQL2DEF, myName, myType, mySize, myFlags );

}//_bnColumn	*tbColumnInsert	( _bnTable *tb )


char	*tbClose	( _bnTable *tb ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

    Error = tb->Error;
    if ( ! tb->Result ) return Error;

#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, tb->Name			);
        printf ( "\n" );
#endif

//2do free ...
    tb->Result = NULL;
    tb->Error[0] = 0;
    tb->db->Error[0] = 0;

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return tb->Error;

}//char	*tbClose	( _bnTable *tb )


char	*tbColumn	( _bnTable *tb ) {//don't use SER
PFLID

    if ( ! tb->Records ) return NULL;

    if ( fetchBuffer ) { free ( fetchBuffer ); fetchBuffer = NULL; }

    tb->FetchColumn->IsNull	= 0;
    tb->FetchColumn->Scale	= 0;

long xxcnt=0;
TDSCOLUMN *curcol = NULL;
    while ( curcol = tds->current_results->columns[xxcnt] ) {
	//printf ( "curcol->column_type=%05ld curcol->column_size=%05ld conv_type=%05s\n", curcol->column_type, curcol->column_size, curcol->column_name );
	if ( strcmp ( curcol->column_name, tb->FetchColumn->Name ) == 0 ) break;
	xxcnt++;
    }//while ( curcol = tds->current_results->columns[xxcnt] )
    if ( ! curcol ) return NULL;
    //printf ( "curcol->column_type=%05ld curcol->column_size=%05ld conv_name=%05s\n", curcol->column_type, curcol->column_size, curcol->column_name );

    if ( curcol->column_type == 106 ) {
        tb->FetchColumn->Size	= curcol->column_prec;
        tb->FetchColumn->Scale	= curcol->column_scale;
    }

TDS_CHAR *src = (TDS_CHAR *)curcol->column_data;
int conv_type = tds_get_conversion_type ( curcol->column_type, curcol->column_size );

    if ( is_blob_type ( curcol->column_type ) ) {//35
    TDSBLOB *blob = (TDSBLOB *) src;
	src = blob->textvalue;
    }

    if ( curcol->column_cur_size < 0 ) {
	tb->FetchColumn->IsNull = 1;
	return NULL;
    }

    if ( curcol->column_type == 34 ) {
	tb->FetchColumn->Size = curcol->column_cur_size;
	fetchBuffer = new char[tb->FetchColumn->Size];
	fetchBuffer[0] = 0;
	memcpy ( fetchBuffer, src, tb->FetchColumn->Size );
	//2do free src
	return fetchBuffer;
    }

CONV_RESULT cr;
    if ( tds_convert( context, conv_type, src, curcol->column_cur_size, SYBVARCHAR, &cr ) < 0 ) return NULL;

    fetchBuffer = new char[1000];
    fetchBuffer[0] = 0;
    strcpy ( fetchBuffer, cr.c );
    if ( cr.c ) free ( cr.c );

    if ( ( curcol->column_type == 106 ) && ( strlen ( fetchBuffer ) >  16 ) ) {
	Error = tb->Error;
	SET_ERROR2 ( "strlen ( %s ) >  16", curcol->column_name );
    }

    if ( ( curcol->column_type ==  35 ) && ( strlen ( fetchBuffer ) > 250 ) ) {
	Error = tb->Error;
	SET_ERROR2 ( "strlen ( %s ) > 250", curcol->column_name );
    }

PFLID
    return fetchBuffer;

}//char	*tbColumn	( _bnTable *tb )


char	*tbRecord	( _bnTable *tb ) {
PFLID

    Error = tb->Error;
    if ( tb->Fokus == 1 ) return Error;

int	result_type;
int	ret = tds_process_tokens ( tds, &result_type, NULL, TDS_RETURN_ROW );
    SIER ( Error );
    if ( result_type == 4052 ) {
	tb->Records = 0;
	return Error;
    }

    return Error;

}//char	*tbRecord	( _bnTable *tb )


char	*tbSQLBuild	( _bnTable *tb ) {
PFLID

    switch ( tb->SQLBuildMode ) {
    	case SELECT:{}break;
    	case INSERT:{}break;
    	case UPDATE:{}break;
	case DELETE:{}break;
    	case SHOW_TABLES:
	    sprintf ( tb->SQLBuild_SQLQuery, "select name as name from sys.tables order by name;" );
	    break;
    }//switch ( tb->SQLBuildMode )

    return tb->Error;

}//char	*tbSQLBuild	( _bnTable *tb )


char	*coDEF	( _bnColumn *co ) {
PFLID

    return DEF2COL ( co, (_DEF2COL *)&DEF2MsSQL );

}//char	*coDEF	( _bnTable *tb )

}//extern "C"
