//#define DEBUG
//#define ACTION
#include <stdio.h>

#define CRLF "<BR>\n"
#include <bnMakro.h>
#include <bnSQL.h>
#include <bnMemInfo.h>

#include <sql.h>
#include <sqlext.h>

#include "DEFODBC.h"


SQLHSTMT  hstmt;
SQLHENV   henv;
SQLHDBC   hdbc;
SQLRETURN retcode = 0;

extern "C" {

    char	*DEF2COL	( _bnColumn  *co, _DEF2COL *DEG2Global );
    _bnColumn	*coInsertX	( _bnTable *tb, _DEF2COL *DEF2Global, char *Name, long Type, long Size, long Flags );
/*
char	*dbClose ( _bnDataBase *db );
*/

char	*ODBC_Errors ( char	*myError ) {
PFLID

SQLCHAR		buf[250];
SQLCHAR		sqlstate[15];
SQLINTEGER	native_error = 0;

int i = 0;
    while (i < 5 && SQLGetDiagRec (SQL_HANDLE_STMT, hstmt, ++i, sqlstate, &native_error, buf, sizeof (buf), NULL) == SQL_SUCCESS) {
	sprintf ( myError, "%s%d: %s (%ld), SQLSTATE=%s\n", myError, i, buf, (long) native_error, sqlstate);
    }

//Get connection errors
    i = 0;
    while (i < 5 && SQLGetDiagRec (SQL_HANDLE_DBC, hdbc, ++i, sqlstate, &native_error, buf, sizeof (buf), NULL) == SQL_SUCCESS) {
	sprintf ( myError, "%s%d: %s (%ld), SQLSTATE=%s\n", myError, i, buf, (long) native_error, sqlstate);
    }

//Get environmen errors
    i = 0;
    while (i < 5 && SQLGetDiagRec (SQL_HANDLE_ENV, henv, ++i, sqlstate, &native_error, buf, sizeof (buf), NULL) == SQL_SUCCESS) {
	sprintf ( myError, "%s%d: %s (%ld), SQLSTATE=%s\n", myError, i, buf, (long) native_error, sqlstate);
    }

    return myError;

}//char	*ODBC_Errors ( char	*myError )


char 	*ODBC1_0_dbOpen ( _bnDataBase *db ) {
PFLID

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

char	*Error = db->Error;

    if ( Error[0] )	return Error;

//pg Defaults
    db->Quote	= ' ';			//use ' ' in SQL

    if ( db->Conn )	return Error;

//login 2 database
#ifdef ACTION
    printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
    printf ( "	%s"		, (char *)__FILE__		);
    printf ( "	~%s"		, db->Base			);
    printf ( "@%s~"		, db->Host			);
    //printf ( " Login=%s"	, db->User			);
    //printf ( "/Passwd=%s"	, db->Pass			);
    printf ( "\n" );
    fflush  ( stdout );
#endif

    if ( SQLAllocHandle ( SQL_HANDLE_ENV, NULL, &henv ) != SQL_SUCCESS ) {
	ODBC_Errors ( Error );	SIER ( Error );
    }

    SQLSetEnvAttr ( henv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER)SQL_OV_ODBC3, SQL_IS_UINTEGER );

    if ( SQLAllocHandle ( SQL_HANDLE_DBC, henv, &hdbc ) != SQL_SUCCESS ) {
	ODBC_Errors ( Error );	SIER ( Error );
    }

SQLCHAR dataSource[1024] = "";
//dataSource[0]= 0;
	//rintf ( (char *) dataSource,"%sSERVER=%s;"	, (char *) dataSource, db->Host		);//org
	sprintf ( (char *) dataSource,"%sServerName=%s;", (char *) dataSource, db->Host		);//psql
	//rintf ( (char *) dataSource,"%sDATABASE=%s;"	, (char *) dataSource, db->Base		);//org
	sprintf ( (char *) dataSource,"%sDBQ=%s;"	, (char *) dataSource, db->Base		);//psql
	sprintf ( (char *) dataSource,"%sUID=%s;"	, (char *) dataSource, db->User		);//org
	sprintf ( (char *) dataSource,"%sPWD=%s;"	, (char *) dataSource, db->Pass		);//org
	//rintf ( (char *) dataSource,"%sDRIVER=%s;"	, (char *) dataSource, "/lib/libodbcabc.so"	);//2do //org
	sprintf ( (char *) dataSource,"%sDRIVER=%s;"	, (char *) dataSource, db->Driver + strlen ("ODBC1.0:")	);//org
//rintf ( (char *) dataSource,"%sDriver=%s;"		, (char *) dataSource, "Pervasive ODBC Interface" );//psql
//rintf ( (char *) dataSource,"%sDescription=%s;"	, (char *) dataSource, "Pervasive ODBC Interface: 10.0.0.35:1583/bntest" );//psql
//rintf ( (char *) dataSource,"%sDBQ=%s;"		, (char *) dataSource, "bntest" );//psql
//rintf ( (char *) dataSource,"%sServerName=%s;"	, (char *) dataSource, "10.0.0.35:1583" );//psql
//rintf ( (char *) dataSource,"%sUID=%s;"		, (char *) dataSource, "dummy" );//psql
//rintf ( (char *) dataSource,"%sPWD=%s;"		, (char *) dataSource, "dummy" );//psql
	sprintf ( (char *) dataSource,"%sOpenMode=%s;"		, (char *) dataSource, "0" );//psql
	sprintf ( (char *) dataSource,"%sPvTranslate=%s;"	, (char *) dataSource, "" );//psql
//sprintf ( (char *) dataSource,"%sDRIVER=%s;"	, (char *) dataSource, "ts02_bntest" );


short buflen;
char buf[1024] = "";
int status = SQLDriverConnect ( hdbc, 0, (UCHAR *)dataSource, SQL_NTS, (UCHAR *)buf, sizeof (buf), &buflen, SQL_DRIVER_COMPLETE );
    if ( status != SQL_SUCCESS && status != SQL_SUCCESS_WITH_INFO ) {
	ODBC_Errors ( Error );	SIER ( Error );
    }
    //2do SQLDriverConnect if first SQLDriverConnect failed

    db->Conn = hdbc;

//2doSQLCHAR driverInfo[255];
//2doSWORD len1;
//2do    status = SQLGetInfo ( hdbc, SQL_DRIVER_VER, driverInfo, sizeof (driverInfo), &len1 );
//2do    if ( status == SQL_SUCCESS )	printf ( "Driver: %s\n", driverInfo );

    if ( SQLAllocHandle ( SQL_HANDLE_STMT, hdbc, &hstmt ) != SQL_SUCCESS ) {//2do mv 2 tbOpen
	ODBC_Errors ( Error );	SIER ( Error );
    }

//all OK
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

    return db->Error;

}//char 	*dbOpen ( _bnDataBase *db )


char	*ODBC1_0_dbClose ( _bnDataBase *db ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

char	*Error = db->Error;

    Error[0] = 0;

//close aktiv conn
    if ( ! db->Conn ) return Error;

#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, db->Base			);
	printf ( "@%s"		, db->Host			);
	//printf ( " Login=%s"	, db->User			);
	//printf ( "/Passwd=%s"	, db->Pass			);
	printf ( "\n" );
	fflush  ( stdout );
#endif
/*bug
    if (hstmt) {
	SQLCloseCursor ( hstmt );
	SQLFreeHandle  ( SQL_HANDLE_STMT, hstmt );
    }
    if (db->Conn)	SQLDisconnect ( hdbc );
    if (hdbc)		SQLFreeHandle ( SQL_HANDLE_DBC, hdbc );
    if (henv)		SQLFreeHandle ( SQL_HANDLE_ENV, henv );
    db->Conn = NULL;
*/
//clean up
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return Error;

}//char	*dbClose ( _bnDataBase *db )


char	*ODBC1_0_tbOpen		( _bnTable *tb ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

char	*Error = tb->Error;

    if ( Error[0]		) return Error;
    if ( ! tb->SQLQuery		) SER ( "! tb->SQLQuery"	);
    if ( ! tb->SQLQuery[0]	) SER ( "! tb->SQLQuery[0]"	);
    if ( tb->Result		) return Error;

#ifdef ACTION
    printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
    printf ( "		%s"	, (char *)__FILE__		);
    printf ( "	%s"		, tb->Name			);
    printf ( "\n" );
    printf ( "SQL=~%s~\n"	, tb->SQLQuery			);
    fflush  ( stdout );
#endif

    if ( SQLPrepare ( hstmt, (UCHAR *)tb->SQLQuery, SQL_NTS ) != SQL_SUCCESS ) {
	ODBC_Errors ( Error );	SIER ( Error );
    }

    if ( SQLExecute ( hstmt ) != SQL_SUCCESS ) {
	ODBC_Errors ( Error );	SIER ( Error );
    }

    tb->Result = hstmt;

SQLSMALLINT numCols;
    if ( SQLNumResultCols ( hstmt, &numCols ) != SQL_SUCCESS ) {
	ODBC_Errors ( Error );	SIER ( Error );
    }

//2do only after fetch SQLLEN nrows = 0;
//2do only after fetch retcode = SQLRowCount ( hstmt, &nrows );//2do never get records here without cursor
//2do only after fetch     if ( SQL_SUCCESS != retcode ) {
//2do only after fetch 	ODBC_Errors ( Error );//SIER ( Error );
//2do only after fetch     }
//2do only after fetch     printf ( "nrows=%ld\n"      , nrows       );

//amount of Records
    tb->Records = -1;
    tb->Fokus   =  0;
//amount of Fields
    tb->Fields  = numCols;

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return tb->Error;

}//char	*tbOpen		( _bnTable *tb )


_bnColumn *ODBC1_0_tbColumnInsert ( _bnTable *tb ) {
PFLID

char *Error = tb->Error;

SQLRETURN     sql_return       = 0;
SQLHSTMT      statement_handle = hstmt;
SQLUSMALLINT  column_number    = tb->ColumnInsertFokus + 1;
SQLCHAR       column_name[255] = "";
SQLSMALLINT   buffer_length    = 255;
SQLSMALLINT   name_length      = 0;
SQLSMALLINT   data_type        = 0;
SQLULEN       column_size      = 0;
SQLSMALLINT   decimal_digits   = 0;
SQLSMALLINT   nullable         = 0;
    sql_return = SQLDescribeCol ( statement_handle, column_number, column_name, buffer_length, &name_length, &data_type, &column_size, &decimal_digits, &nullable );
    if ( sql_return != SQL_SUCCESS ) {
	ODBC_Errors ( Error ); SIE ( Error );
	return NULL;
    }
#ifdef DEBUG
    printf ( "SQLRETURN    sql_return       = %ld\n" , sql_return       );
    printf ( "SQLHSTMT     statement_handle = 0x%X\n", statement_handle );
    printf ( "SQLUSMALLINT column_number    = %ld\n" , column_number    );
    printf ( "SQLCHAR      column_name      = %s\n"  , column_name      );
    printf ( "SQLSMALLINT  buffer_length    = %ld\n" , buffer_length    );
    printf ( "SQLSMALLINT  name_length      = %ld\n" , name_length      );
    printf ( "SQLSMALLINT  data_type        = %ld\n"  , (long)data_type        );
    printf ( "SQLULEN      column_size      = %ld\n" , column_size      );
    printf ( "SQLSMALLINT  decimal_digits   = %ld\n" , decimal_digits   );
    printf ( "SQLSMALLINT  nullable         = %ld\n" , nullable         );
#endif

char *myName = new char[255];
    strcpy ( myName, (char *)column_name );
long myType  = data_type;
long mySize  = column_size;
long myFlags = 0;

//Flags Mapping
    //if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_PRI_KEY;
    //if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_AUTO_INCREMENT;
    //printf ( "Type=%05ld Size=%05ld Name=%25s\n", myType, mySize, myName );

    return coInsertX ( tb, (_DEF2COL *)&ODBC2DEF, myName, myType, mySize, myFlags );

}//_bnColumn *ODBC1_0_tbColumnInsert ( _bnTable *tb )


char	*ODBC1_0_tbClose	( _bnTable *tb ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

char	*Error = tb->Error;

    Error[0] = 0;
    if ( ! tb->Result ) return Error;
/*bug*/
#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, tb->Name			);
        printf ( "\n" );
#endif

//clean up
    SQLCloseCursor ( hstmt );
    tb->Result = NULL;

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return Error;

}//char	*tbClose	( _bnTable *tb )


char *ODBC1_0_tbColumn ( _bnTable *tb ) {
PFLID

char	*Error = tb->Error;
    if ( ! tb->Records )	return NULL;

    tb->FetchColumn->IsNull = 0;

//tb->FetchColumn->RawType = 0;
#ifdef DEBUG
    printf ( "tb->FetchColumn->Name=%s\n", tb->FetchColumn->Name );
#endif

SQLUSMALLINT  currNum = 0;
SQLRETURN     sql_return       = 0;
SQLHSTMT      statement_handle = hstmt;
SQLUSMALLINT  column_number    = tb->ColumnInsertFokus + 1;
SQLCHAR       column_name[255] = "";
SQLSMALLINT   buffer_length    = 255;
SQLSMALLINT   name_length      = 0;
SQLSMALLINT   data_type        = 0;
SQLULEN       column_size      = 0;
SQLSMALLINT   decimal_digits   = 0;
SQLSMALLINT   nullable         = 0;

    for ( short colNum = 1; colNum <= tb->Fields; colNum++ ) {
PFLID
	column_number  = colNum;
	column_name[0] = 0;
	sql_return = SQLDescribeCol ( statement_handle, column_number, column_name, buffer_length, &name_length, &data_type, &column_size, &decimal_digits, &nullable );
	if ( sql_return != SQL_SUCCESS ) {
	    ODBC_Errors ( Error ); SIE ( Error );
	    return NULL;
	}
#ifdef DEBUGx
	printf ( "	SQLRETURN     sql_return       = %ld\n" , sql_return       );
	printf ( "	SQLHSTMT      statement_handle = 0x%X\n", statement_handle );
	printf ( "	SQLUSMALLINT  column_number    = %ld\n" , column_number    );
	printf ( "	SQLCHAR       column_name      = %s\n"  , column_name      );
	printf ( "	SQLSMALLINT   buffer_length    = %ld\n" , buffer_length    );
	printf ( "	SQLSMALLINT   name_length      = %ld\n" , name_length      );
	printf ( "	SQLSMALLINT   data_type        = %ld\n" , data_type        );
	printf ( "	SQLULEN       column_size      = %ld\n" , column_size      );
	printf ( "	SQLSMALLINT   decimal_digits   = %ld\n" , decimal_digits   );
	printf ( "	SQLSMALLINT   nullable         = %ld\n" , nullable         );
#endif
	if ( strcmp ( (char *)column_name, tb->FetchColumn->Name ) == 0 ) currNum = colNum;
	if ( currNum ) break;
    }//for (colNum = 1; colNum <= numCols; colNum++)
PFLID
    if ( ! currNum ) return NULL;
#ifdef DEBUG
    printf ( "SQLRETURN     sql_return       = %ld\n" , sql_return       );
    printf ( "SQLHSTMT      statement_handle = 0x%X\n", statement_handle );
    printf ( "SQLUSMALLINT  column_number    = %ld\n" , column_number    );
    printf ( "SQLCHAR       column_name      = %s\n"  , column_name      );
    printf ( "SQLSMALLINT   buffer_length    = %ld\n" , buffer_length    );
    printf ( "SQLSMALLINT   name_length      = %ld\n" , name_length      );
    printf ( "SQLSMALLINT  data_type        = %ld\n"  , (long)data_type        );
    printf ( "SQLULEN       column_size      = %ld\n" , column_size      );
    printf ( "SQLSMALLINT   decimal_digits   = %ld\n" , decimal_digits   );
    printf ( "SQLSMALLINT   nullable         = %ld\n" , nullable         );
#endif

char strData[1000];	//2do malloc
    memset ( strData, 0x00, 1000 );

SDWORD colIndicator;

//tb->FetchColumn->RawType	= data_type;
    tb->FetchColumn->Scale	= decimal_digits;
PFLID
    if ( data_type == -1 || data_type == -4 ) {//BINARY
PFLID
//xxx 	colIndicator = 0;
//xxx 	printf ( "colIndicator=%ld\n", colIndicator );
//xxx PFLID
//xxx 	SQLGetData ( hstmt, currNum, SQL_BINARY, NULL, 0, (SQLLEN *) &colIndicator );
//xxx PFLID
//xxx 	tb->FetchColumn->Size = colIndicator;
//xxx 	printf ( "tb->FetchColumn->Size=%ld\n", tb->FetchColumn->Size );
//xxx 	if ( tb->FetchColumn->Size <= 0 ) {
//xxx 	     tb->FetchColumn->IsNull	= 1;
//xxx 	     tb->FetchColumn->Size	= 0;
//xxx 	    return NULL;
//xxx 	}
PFLID
//tb->FetchColumn->Size = 6000;
SDWORD tb_FetchColumn_Size = 17000;
PFLID
    char *binData = new char[tb_FetchColumn_Size];
PFLID
	if ( SQLGetData ( hstmt, currNum, SQL_BINARY, binData, tb_FetchColumn_Size, (SQLLEN *) &colIndicator ) != SQL_SUCCESS ) {
/*
	    ODBC_Errors ( Error );	SIE ( Error );
	    return NULL;
*/
	}
tb->FetchColumn->Size = colIndicator;
PFLID
printf ( "colIndicator=%ld\n", colIndicator );
printf ( "tb_FetchColumn_Size=%ld\n", tb_FetchColumn_Size );
printf ( "binData[0]=%x\n", binData[0] );
printf ( "LONG_VARCHAR ok @ linux psql....\n" );
PFLID
	return binData;

    }//if ( data_type == -1 || data_type == -4 )

//2do    else if ( ( data_type == 333 ) || ( data_type == 8 ) ) {
//2do    double	xxxdoub;
//2do	if (SQLGetData (hstmt, currNum, SQL_DOUBLE, (void *)&xxxdoub,sizeof (double), &colIndicator) != SQL_SUCCESS) {
//2do	    ODBC_Errors ( Error );	SIE ( Error );
//2do	    return NULL;
//2do	}
//2do	sprintf ( strData, "%f", xxxdoub );
//2do    }
//2do    else if ( data_type == 92 ) {//TIME
//2do    SQL_TIMESTAMP_STRUCT	myTime;
//2do	if (SQLGetData (hstmt, currNum, SQL_TIMESTAMP, &myTime,sizeof (myTime), &colIndicator) != SQL_SUCCESS) {
//2do	    ODBC_Errors ( Error );	SIE ( Error );
//2do	    return NULL;
//2do	}
//2do	myTime.fraction = 0;
//2do	sprintf ( strData, "%02ld:%02ld:%02ld.%06ld"
//2do	    , myTime.hour
//2do	    , myTime.minute
//2do	    , myTime.second
//2do	    , myTime.fraction
//2do	);
//2do    }//if ( data_type == 92 )

    else if ( data_type == 93 ) {//TIMESTAMP
PFLID
    SQL_TIMESTAMP_STRUCT	myTime;
	if (SQLGetData (hstmt, currNum, SQL_TIMESTAMP, &myTime,sizeof (myTime), (SQLLEN *) &colIndicator) != SQL_SUCCESS) {
	    ODBC_Errors ( Error );	SIE ( Error );
	    return NULL;
	}
	myTime.fraction /= 1000;
	sprintf ( strData, "%4ld-%02ld-%02ld %02ld:%02ld:%02ld.%06ld"
	    , myTime.year
	    , myTime.month
	    , myTime.day
	    , myTime.hour
	    , myTime.minute
	    , myTime.second
	    , myTime.fraction
	);
    }//if ( data_type == 93 )
    else {
PFLID
	if ( SQLGetData ( hstmt, currNum, SQL_CHAR, strData, sizeof ( strData ), (SQLLEN *) &colIndicator ) != SQL_SUCCESS ) {
	    ODBC_Errors ( Error ); SIE ( Error );
	    return NULL;
	}
    }

    if ( colIndicator == SQL_NULL_DATA ) tb->FetchColumn->IsNull = 1;

#define GUPTA2MS
#ifdef  GUPTA2MS
    if ( data_type == 91 && strData[0] ) strcat ( strData, " 00:00:00.000000" );
    if ( data_type == 93 && tb->FetchColumn->IsNull ) strcpy ( strData, "" );
#endif

#ifdef DEBUG
    printf ( "strData=~%s~\n", strData );
#endif
    return strData;

}//char *ODBC1_0_tbColumn ( _bnTable *tb )


char	*ODBC1_0_tbRecord	( _bnTable *tb ) {
PFLID

char	*Error = tb->Error;

int	 sts =  SQLFetch ( hstmt );
    if ( sts == SQL_NO_DATA_FOUND ) {
	tb->Records = 0;
	return Error;
    }

    if ( sts != SQL_SUCCESS		)  ODBC_Errors ( Error );
    SIER ( Error );

//2do.odbc.ms. if ( -1 == tb->Records ) {
//2do.odbc.ms.     SQLLEN nrows = 0;
//2do.odbc.ms.     retcode = SQLRowCount ( hstmt, &nrows );//2do never get records here without cursor
//2do.odbc.ms. 	if ( SQL_SUCCESS != retcode ) {
//2do.odbc.ms. 	    ODBC_Errors ( Error );//SIER ( Error );
//2do.odbc.ms. 	}
//2do.odbc.ms. 	printf ( "nrows=%ld\n"      , nrows       );
//2do.odbc.ms. 	tb->Records = nrows;
//2do.odbc.ms.     }

    return Error;

}//char	*tbRecord	( _bnTable *tb )


char	*ODBC1_0_tbSQLBuild	( _bnTable *tb ) {
PFLID

//2do    switch ( tb->SQLBuildMode ) {
//2do    	case SELECT:{}break;
//2do    	case INSERT:{}break;
//2do    	case UPDATE:{}break;
//2do	case DELETE:{}break;
//2do    	case SHOW_TABLES:
//2do	    sprintf ( tb->SQLBuild_SQLQuery, "select tablename as name from pg_tables where schemaname='public' order by tablename;" );
//2do	    break;
//2do    }//switch ( tb->SQLBuildMode )

    return tb->Error;

}//char	*tbSQLBuild	( _bnTable *tb )


char	*ODBC1_0_coDEF	( _bnColumn *co ) {
PFLID

    return DEF2COL ( co, (_DEF2COL *)&DEF2ODBC );

}//char	*coDEF	( _bnTable *tb )


}//extern "C"
