//#define DEBUG
//#define ACTION
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define CRLF "<BR>\n"
#include <bnMakro.h>

#include <libpq-fe.h>

#include "bnSQL.h"
#include "bnMemInfo.h"
#include "DEFPostgres.h"


extern "C" {

    char	*DEF2COL	( _bnColumn  *co, _DEF2COL *DEG2Global );
    _bnColumn	*coInsertX	( _bnTable *tb, _DEF2COL *DEF2Global, char *Name, long Type, long Size, long Flags );

char	*dbClose ( _bnDataBase *db );

char 	*dbOpen ( _bnDataBase *db ) {
PFLID
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

//error check
    if ( db->Error[0] )	return db->Error;

//pg Defaults
    db->Quote	= '"';			//use " in SQL

//login 2 database
    if ( ! db->Conn ) {

    char *db__TTY = NULL;
        //TTY		//debugging tty for the backend server		//2do extract from db->Options
	//Options	//special options to start up the backend server//2do extract from db->Options
#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, db->Base			);
	printf ( "@%s"		, db->Host			);
	//printf ( " Login=%s"	, db->User			);
	//printf ( "/Passwd=%s"	, db->Pass			);
	printf ( "\n" );
	fflush  ( stdout );
#endif

    //login 2 database
	db->Conn = PQsetdbLogin( db->Host, db->Port, db->Options, db__TTY, db->Base, db->User, db->Pass );
    //check to see that the backend login was successfully made
	if ( PQstatus( (PGconn *)db->Conn ) == CONNECTION_BAD ) {

	//login 2 database
	    db->Conn = PQsetdbLogin( db->Host, db->Port, db->Options, db__TTY, db->Base, db->User, db->Pass );
	//check to see that the backend login was successfully made
	    if ( PQstatus( (PGconn *)db->Conn ) == CONNECTION_BAD ) {
		sprintf ( db->Error , "Connection to ~%s@%s~ failed !\nError \"%s\" !", db->Base, db->Host, PQerrorMessage( (PGconn *)db->Conn ) );
		PQfinish( (PGconn *)db->Conn );	//2do
		dbClose ( db );
	    }//if ( PQstatus( DB->Conn ) == CONNECTION_BAD )

	}//if ( PQstatus( DB->Conn ) == CONNECTION_BAD )

    }//if ( ! db->Conn )
    //login 2 database done

//all OK
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return db->Error;

}//char 	*dbOpen ( _bnDataBase *db )


char	*dbClose ( _bnDataBase *db ) {
PFLID
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

//close aktiv conn
    if ( db->Conn ) {
#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, db->Base			);
	printf ( "@%s"		, db->Host			);
	//printf ( " Login=%s"	, db->User			);
	//printf ( "/Passwd=%s"	, db->Pass			);
	printf ( "\n" );
	fflush  ( stdout );
#endif

    //close aktiv conn
	if ( PQstatus( (PGconn *)db->Conn ) == 0 ) PQfinish ( (PGconn *)db->Conn );//2do 1032 of this are not unalloc
	db->Conn = NULL;

    }//if ( DB->Conn )
//close aktiv conn done

//clean up
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return db->Error;

}//char	*dbClose ( _bnDataBase *db )


char	*tbOpen		( _bnTable *tb ) {
PFLID
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

//error check
	 if ( ! tb->SQLQuery    ) sprintf ( tb->Error, "%s @ %s[%ld]", "! tb->SQLQuery"		, __PRETTY_FUNCTION__, __LINE__ );
    else if ( ! tb->SQLQuery[0] ) sprintf ( tb->Error, "%s @ %s[%ld]", "! tb->SQLQuery[0]"	, __PRETTY_FUNCTION__, __LINE__ );
    if ( tb->Error[0] ) return tb->Error;

    if ( tb->Result ) return tb->Error;
char	*Error = tb->Error;

#ifdef ACTION
    printf ( "%s"			, (char *)__PRETTY_FUNCTION__	);
    printf ( "		%s"	, (char *)__FILE__		);
    printf ( "	%s"		, tb->Name			);
    printf ( "\n" );
    printf ( "SQL=~%s~\n"		, tb->SQLQuery );
    fflush  ( stdout );
#endif

//PQexec
char	*xer = NULL;
    tb->Result = PQexec ( (PGconn *)tb->db->Conn, tb->SQLQuery );
    xer = PQerrorMessage( (PGconn *)tb->db->Conn );
    if ( xer == NULL ) SER ( "xer == NULL" );
    //printf ( "01------------%ld->%s<-%ld--\n", xer, xer, strlen (xer) );
//reconnect
    if ( strlen ( xer ) ) {
    long	reConnX = 0;
	if ( strncmp ( xer, "Connection to"	, strlen ("Connection to"	) ) == 0 ) reConnX = 1;
	if ( strncmp ( xer, "FATAL:"		, strlen ("FATAL:"		) ) == 0 ) reConnX = 1;
	if ( reConnX ) {
	    dbClose ( tb->db );	SIER ( tb->db->Error );
	    dbOpen  ( tb->db );	SIER ( tb->db->Error );
	    tb->Result = PQexec ( (PGconn *)tb->db->Conn, tb->SQLQuery );
	    xer = PQerrorMessage( (PGconn *)tb->db->Conn );
	    if ( xer == NULL ) SER ( "xer == NULL" );
	    //printf ( "RE------------%ld->%s<-%ld--\n", xer, xer, strlen (xer) );
	    SIER ( xer );
	}//if ( reConnX )
	else
	    SER ( xer );
    }//if ( strlen ( xer ) )
//reconnect done

//error check
    if ( tb->Error[0] ) return tb->Error;

//amount of Records
    tb->Records = PQntuples( (PGresult *)tb->Result );

//amount of Fields
    tb->Fields  = PQnfields( (PGresult *)tb->Result );

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return tb->Error;

}//char	*tbOpen		( _bnTable *tb )


_bnColumn	*tbColumnInsert	( _bnTable *tb ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

char	*myName = PQfname( (PGresult *)tb->Result, tb->ColumnInsertFokus );
long	 myType = PQftype( (PGresult *)tb->Result, tb->ColumnInsertFokus );
long	 mySize = PQfsize( (PGresult *)tb->Result, tb->ColumnInsertFokus );//bug always -1
long	 myFlags = 0;

//Flags Mapping
    if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_PRI_KEY;
    if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_AUTO_INCREMENT;

    return    coInsertX	( tb, (_DEF2COL *)&Postgres2DEF, myName, myType, mySize, myFlags );

}//_bnColumn	*tbColumnInsert	( _bnTable *tb )


char	*tbClose	( _bnTable *tb ) {
PFLID
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

    if ( tb->Result ) {
#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, tb->Name			);
        printf ( "\n" );
#endif

    //close table
	PQclear( (PGresult *)tb->Result );
	tb->Result = NULL;

    }//if ( tb->Result )

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    tb->Error[0] = 0;
    tb->db->Error[0] = 0;
    return tb->Error;

}//char	*tbClose	( _bnTable *tb )


char	*tbColumn	( _bnTable *tb ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif
int	i;

    if ( tb->Records == 0 )	return NULL;

//i 2 field Nr
    for (i = 0; i < tb->Fields; i++)
	if ( strcmp ( tb->FetchColumn->Name, PQfname( (PGresult *)tb->Result, i ) ) == 0 )
	    break;

    if (tb->Fields <= i )	return NULL;
    else			return PQgetvalue( (PGresult *)tb->Result, tb->Fokus - 1, i );

}//char	*tbColumn	( _bnTable *tb )


char	*tbRecord	( _bnTable *tb ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

//fetch record, done in tbColumn via Fokus

    return tb->Error;

}//char	*tbRecord	( _bnTable *tb )


char	*tbSQLBuild	( _bnTable *tb ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

    switch ( tb->SQLBuildMode ) {
    	case SELECT:{}break;
    	case INSERT:{}break;
    	case UPDATE:{}break;
	case DELETE:{}break;
    	case SHOW_TABLES:
	    sprintf ( tb->SQLBuild_SQLQuery, "select tablename as name from pg_tables where schemaname='public' order by tablename;" );
	    break;
    }//switch ( tb->SQLBuildMode )
    return tb->Error;

}//char	*tbSQLBuild	( _bnTable *tb )


char	*coDEF	( _bnColumn *co ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

    return DEF2COL ( co, (_DEF2COL *)&DEF2Postgres );

}//char	*coDEF	( _bnTable *tb )

}//extern "C"
