#include <stdio.h>

#include "sqlite3.h"


static int run_table_dump_query ( sqlite3 *db, const char *zSelect ) {
sqlite3_stmt	*pSelect;
int		 rc;

    rc = sqlite3_prepare ( db, zSelect, -1, &pSelect, 0 );
    if ( rc != SQLITE_OK || !pSelect ) {
	return rc;
    }

    rc = sqlite3_step(pSelect);

int Cols=  sqlite3_column_count(pSelect);
    printf ( "Cols=%ld\n", Cols );

    while ( rc==SQLITE_ROW ) {
	for ( int xCol = 0; xCol < Cols; xCol++ ) {
	    printf ( "%10s ", sqlite3_column_name(pSelect, xCol) );
	    printf ( "%02ld ", sqlite3_column_type(pSelect, xCol) );
	    printf ( "%10s ", sqlite3_column_decltype(pSelect, xCol) );
//	    printf ( "bytes=%ld ", sqlite3_column_bytes(pSelect, xCol) );

	const unsigned char *ymxxx = sqlite3_column_text( pSelect, xCol );
	    printf ( "d=%40s\n", ymxxx );
	}//for ( xCol = 0; xCol < Cols; xCol++ )
	rc = sqlite3_step(pSelect);
	//break;
    }//while ( rc==SQLITE_ROW )

}//static int run_table_dump_query ( sqlite3 *db, const char *zSelect )


int	main	( void ) {
//const char *filename = "search.sqlite";
const char *filename = "search.sqlitex";
sqlite3 *db;

int xx= sqlite3_open( filename, &db );
    printf ( "xx=%ld %ld\n", xx, db );

    if( db==0 || SQLITE_OK!=sqlite3_errcode(db) ){
      fprintf(stderr,"Unable to open database \"%s\": %s\n", 
          filename, sqlite3_errmsg(db));
    }

//    run_table_dump_query( db, "create table dummy (abc integer , def char(244))" );
//    run_table_dump_query( db, "insert into dummy values (4,'d')" );
//    run_table_dump_query( db, "PRAGMA database_list;");
//    run_table_dump_query( db, "SELECT name FROM sqlite_master WHERE type='table'" );
//    run_table_dump_query( db, "SELECT * FROM sqlite_master" );
//    run_table_dump_query( db, "PRAGMA index_list;");
//    run_table_dump_query( db, "PRAGMA table_info (dummy);");
//    run_table_dump_query( db, "select * from dummy");
//    run_table_dump_query( db, "select * from engine_data");
//    run_table_dump_query( db, "insert into dummy values (5,'e')");
    sqlite3_close(db);

}//int	main	( void )
