//#define DEBUG
//#define ACTION
#include <stdio.h>
#include <stdlib.h>

#define CRLF "<BR>\n"
#include <bnMakro.h>
#include <bnSQL.h>
#include <bnMemInfo.h>

#include <sqlite3.h>

#include "DEFSQLite.h"


//sqlite_master.type='table'|'index'|'trigger'|'view'
//sqlite_master.name
//sqlite_master.tbl_name
//sqlite_master.rootpage
//sqlite_master.sql

char			*fetchBuffer = NULL;


extern "C" {

    char	*DEF2COL	( _bnColumn  *co, _DEF2COL *DEG2Global );
    _bnColumn	*coInsertX	( _bnTable *tb, _DEF2COL *DEF2Global, char *Name, long Type, long Size, long Flags );

char 	*dbOpen ( _bnDataBase *db ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

char *Error = db->Error;
    if ( Error[0] ) return Error;

//Defaults
    db->Quote	= ' ';

    if ( db->Conn ) return Error;

#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, db->Base			);
	printf ( "@%s"		, db->Host			);
	//printf ( " Login=%s"	, db->User			);
	//printf ( "/Passwd=%s"	, db->Pass			);
	printf ( "\n" );
	fflush  ( stdout );
#endif

sqlite3 *SQLite3 = NULL;
char	FileName[255];

    sprintf ( FileName, "%s/%s", db->Host, db->Base	);

int		 rc;
    rc = sqlite3_open ( FileName, &SQLite3 );
    if ( rc != SQLITE_OK ) SER ( sqlite3_errmsg ( SQLite3 ) );
    if ( ! SQLite3	 ) SER ( "! SQLite3" );

    db->Conn = SQLite3;

//all OK
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return db->Error;

}//char 	*dbOpen ( _bnDataBase *db )


char	*dbClose ( _bnDataBase *db ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

char *Error = db->Error;

//close aktiv conn
    if ( ! db->Conn ) return Error;

#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, db->Base			);
	printf ( "@%s"		, db->Host			);
	//printf ( " Login=%s"	, db->User			);
	//printf ( "/Passwd=%s"	, db->Pass			);
	printf ( "\n" );
	fflush  ( stdout );
#endif

sqlite3 *SQLite3 = (sqlite3 *)db->Conn;
    sqlite3_close ( SQLite3 );
    db->Conn = NULL;

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return Error;

}//char	*dbClose ( _bnDataBase *db )


char	*tbOpen		( _bnTable *tb ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

char *Error = tb->Error;

    if ( tb->Result		) return tb->Error;
    if ( ! tb->SQLQuery		) SER ( "! tb->SQLQuery"	);
    if ( ! tb->SQLQuery[0]	) SER ( "! tb->SQLQuery[0]"	);

#ifdef ACTION
    printf ( "%s"			, (char *)__PRETTY_FUNCTION__	);
    printf ( "		%s"	, (char *)__FILE__		);
    printf ( "	%s"		, tb->Name			);
    printf ( "\n" );
    printf ( "SQL=~%s~\n"		, tb->SQLQuery );
    fflush  ( stdout );
#endif

sqlite3 *SQLite3 = (sqlite3 *)tb->db->Conn;

int rc;
sqlite3_stmt	*pSelect;
    rc = sqlite3_prepare ( SQLite3, tb->SQLQuery, -1, &pSelect, 0 );
    if ( rc != SQLITE_OK ) SER ( sqlite3_errmsg ( SQLite3 ) );
    if ( ! pSelect	 ) SER ( "! pSelect" );

    rc = sqlite3_step ( pSelect );
    if ( rc != SQLITE_ROW ) return Error;

//2do reconnect if error
    tb->Result = (void *)pSelect;

//error check
    if ( Error[0] ) return Error;

//amount of Records
    tb->Records = -1;
    tb->Fokus   =  0;
//amount of Fields
    tb->Fields  = sqlite3_column_count(pSelect);

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return tb->Error;

}//char	*tbOpen		( _bnTable *tb )


_bnColumn	*tbColumnInsert	( _bnTable *tb ) {
PFLID

sqlite3_stmt	*pSelect = (sqlite3_stmt *)tb->Result;

char	*decltype = (char *)sqlite3_column_decltype ( pSelect, tb->ColumnInsertFokus );
char	*myName   = (char *)sqlite3_column_name     ( pSelect, tb->ColumnInsertFokus );
long	 myType = 0;
long	 mySize = 0;//curcol->column_size;2do
long	 myFlags= 0;

    //printf ( "name=%30s  "	, myName	);
long typE = sqlite3_column_type ( pSelect, tb->ColumnInsertFokus );
    //printf ( "type=%02ld "	, typE );
    //printf ( "decltype=%10s "	, decltype	);
    //printf ( "byte=%06ld\n"	, sqlite3_column_bytes ( pSelect, tb->ColumnInsertFokus ) );

//#define SQLITE_INTEGER  1
//#define SQLITE_FLOAT    2
//#define SQLITE_TEXT     3
//#define SQLITE_BLOB     4
//#define SQLITE_NULL     5
    if ( decltype ) {
	if ( strcmp ( decltype,    "TEXT" ) == 0 ) myType = SQLITE_TEXT;
	if ( strcmp ( decltype,    "text" ) == 0 ) myType = SQLITE_TEXT;
	if ( strcmp ( decltype, "INTEGER" ) == 0 ) myType = SQLITE_INTEGER;
	if ( strcmp ( decltype, "integer" ) == 0 ) myType = SQLITE_INTEGER;
	if ( strcmp ( decltype,    "LONG" ) == 0 ) myType = SQLITE_INTEGER;
	if ( strcmp ( decltype,    "long" ) == 0 ) myType = SQLITE_INTEGER;
	if ( strcmp ( decltype,    "BLOB" ) == 0 ) myType = SQLITE_BLOB;
	if ( strcmp ( decltype,    "blob" ) == 0 ) myType = SQLITE_BLOB;
	if ( strcmp ( decltype,   "FLOAT" ) == 0 ) myType = SQLITE_FLOAT;//2do checkit
	if ( strcmp ( decltype,   "float" ) == 0 ) myType = SQLITE_FLOAT;
	if ( strcmp ( decltype,  "DOUBLE" ) == 0 ) myType = SQLITE_FLOAT;//2do checkit
	if ( strcmp ( decltype,  "double" ) == 0 ) myType = SQLITE_FLOAT;
    }//if ( decltype )
    else {
	myType = typE;
    }
//Flags Mapping
    //if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_PRI_KEY;
    //if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_AUTO_INCREMENT;

    return    coInsertX	( tb, (_DEF2COL *)&SQLite2DEF, myName, myType, mySize, myFlags );

}//_bnColumn	*tbColumnInsert	( _bnTable *tb )


char	*tbClose	( _bnTable *tb ) {
PFLID
#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif

char *Error = tb->Error;

    if ( ! tb->Result ) return Error;

#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, tb->Name			);
        printf ( "\n" );
#endif

sqlite3_stmt	*pSelect = (sqlite3_stmt *)tb->Result;
    sqlite3_free ( pSelect );
//2do bnMemInfo
    tb->Result = NULL;
    tb->Error[0] = 0;
    tb->db->Error[0] = 0;

#ifdef DEBUG
    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
#endif
    return tb->Error;

}//char	*tbClose	( _bnTable *tb )


char	retStr[10000];
char	*tbColumn	( _bnTable *tb ) {//don't use SER
PFLID

    if ( ! tb->Records ) return NULL;

    if ( fetchBuffer ) { free ( fetchBuffer ); fetchBuffer = NULL; }

sqlite3_stmt	*pSelect = (sqlite3_stmt *)tb->Result;

int xCol = 0;
    for ( xCol = 0; xCol < tb->Fields; xCol++ )
	if ( strcmp ( sqlite3_column_name(pSelect, xCol), tb->FetchColumn->Name ) == 0 ) break;

    //printf ( "name = %s\n", (char *)sqlite3_column_name( pSelect, xCol ) );
char	*decltype = (char *)sqlite3_column_decltype ( pSelect, xCol );
long 	 str__len = sqlite3_column_bytes( pSelect, xCol );
long	 Type     = sqlite3_column_type ( pSelect, xCol );
    //printf ( "decl=%10s size=%ld\n", decltype, str__len );

    if ( Type == 5  ) {
	tb->FetchColumn->IsNull = 1;
	return NULL;
    }

    if ( ! str__len ) return "";

    if ( ( decltype ) && ( strcmp ( decltype, "BLOB" ) == 0 ) ) {
	if ( Type == 4 ) {
	    tb->FetchColumn->Size = str__len;
	    fetchBuffer = new char[tb->FetchColumn->Size + 1];
	    fetchBuffer[0] = 0;
	    memcpy ( fetchBuffer, (char *)sqlite3_column_blob ( pSelect, xCol ), tb->FetchColumn->Size );
	    return fetchBuffer;
	}//if ( Type == 5 )
    }//if ( strcmp ( decltype, "BLOB" ) == 0 )

    retStr[0] = 0;
    strcpy ( retStr, (char *)sqlite3_column_text( pSelect, xCol ) );
    //printf ( "retStr=%s\n", retStr );
    retStr[255] = 0;

    return retStr;

}//char	*tbColumn	( _bnTable *tb )


char	*tbRecord	( _bnTable *tb ) {
PFLID

char *Error = tb->Error;

    if ( tb->Fokus == 1 ) return Error;

sqlite3_stmt	*pSelect = (sqlite3_stmt *)tb->Result;

int rc = sqlite3_step ( pSelect );
    if ( rc != SQLITE_ROW ) {
	tb->Records = 0;
	return Error;
    }

    return Error;

}//char	*tbRecord	( _bnTable *tb )


char	*tbSQLBuild	( _bnTable *tb ) {
PFLID

    switch ( tb->SQLBuildMode ) {
    	case SELECT:{}break;
    	case INSERT:{}break;
    	case UPDATE:{}break;
	case DELETE:{}break;
    	case SHOW_TABLES:
	    sprintf ( tb->SQLBuild_SQLQuery, "SELECT name FROM sqlite_master WHERE type='table';" );
	    break;
    }//switch ( tb->SQLBuildMode )

    return tb->Error;

}//char	*tbSQLBuild	( _bnTable *tb )


char	*coDEF	( _bnColumn *co ) {
PFLID

    return DEF2COL ( co, (_DEF2COL *)&DEF2SQLite );

}//char	*coDEF	( _bnTable *tb )

}//extern "C"
