//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include <bncsql.h>
//#define bncSQL_DEBUG
#include <albus_log.h>
#ifndef bncSQL_DEBUG
# undef  ER
# define ER
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif
#undef ER

long  mysql_API_Version = bncSQL_API_VERSION;
char  mysql_Version[]   = "1.0.1";

//#define UNDEF_THREADS_HACK
#include <mysql.h>
#include <errmsg.h>

#define SC_MAXWIDTH	256		// Max width of screen (for error messages)
#define ERRMSGSIZE	(SC_MAXWIDTH)	// Max length of a error message
#define NRERRBUFFS	(2)		// Buffers for parameters


char errbuff[NRERRBUFFS][ERRMSGSIZE];



extern "C" {

char *mysql_dbOpen ( _bncDataBase *db ) {
    D9 ( "db=%p", db );

char *Error = db->Error;
    if ( Error[0] ) return NULL;

//mySQL Defaults
    db->Quote	= ' ';

//login 2 database
    if ( ! db->Conn ) {
    //char *db__TTY = NULL;
	//Options	//special options to start up the backend server//2do extract from db->Options
	D2 ( "db->Host=%s" , db->Host );
	D2 ( "db->Port=%ld", db->Port );
	D2 ( "db->Base=%s" , db->Base );
	D2 ( "db->User=%s" , db->User );
	D9 ( "db->Pass=%s" , db->Pass );//D9

//db->Conn
	db->Conn = new MYSQL;

	long		mysql_port	=0;		//2do
	char		*mysql_unix_port=0;		//2do
	static int	connect_flag	=CLIENT_INTERACTIVE;//2do ???

	if ( db->Port ) mysql_port = db->Port;

	memset ((char*) db->Conn, 0x00, sizeof(db->Conn));
	D9 ( "db=%p mysql_init", db );
	mysql_init ( (MYSQL *)db->Conn );

	D9 ( "db=%p mysql_real_connect", db );
	if ( !mysql_real_connect( (MYSQL *)db->Conn, db->Host, db->User, db->Pass, db->Base, mysql_port, mysql_unix_port, connect_flag) ) {
	    sprintf( db->Error, "%d	%s\n", mysql_errno( (MYSQL *)db->Conn ), mysql_error( (MYSQL *)db->Conn ) );
	    if ( (mysql_errno( (MYSQL *)db->Conn ) != CR_CONN_HOST_ERROR && mysql_errno( (MYSQL *)db->Conn ) != CR_CONNECTION_ERROR)) {
		//dbClose();	//2do
		return NULL;			// Abort
	    }
	    //dbClose();	//2do
	    return NULL;			// Retryable
	}

	((MYSQL *)db->Conn)->reconnect=0; // We want to know if this happens
    }//if ( ! db->Conn )
    //login 2 database done

    D9 ( "db=%p done", db );

//all OK
    return NULL;

}//char *mysql_dbOpen ( _bncDataBase *db )


char *mysql_dbClose ( _bncDataBase *db ) {
    D9 ( "db=%p", db );

char *Error = db->Error;
    if ( Error[0] ) return NULL;//2do check, rm

//close aktiv conn
    if ( db->Conn ) {
	D9 ( " db->Base=%s", db->Base );
	D9 ( " db->Host=%s", db->Host );
    //close aktiv conn
	mysql_close( (MYSQL *)db->Conn );
	mysql_server_end();
	free ( db->Conn );
	db->Conn = NULL;
    }//if ( db->Conn )
//close aktiv conn done

    return NULL;

}//char *mysql_dbClose ( _bncDataBase *db )


char *mysql_tbOpen ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
    if ( Error[0] ) return NULL;

//error check
    if ( ! tb->Query    ) SER ( "! tb->Query"    );
    if ( ! tb->Query[0] ) SER ( "! tb->Query[0]" );
    if (   tb->Result   ) return NULL;

    D9 ( "tb->Query=~%s~", tb->Query );

    if ( mysql_real_query( (MYSQL *)tb->db->Conn, tb->Query,strlen (tb->Query) ) ) {
	sprintf( tb->Error, "MYSQL:%d %s\n", mysql_errno( (MYSQL *)tb->db->Conn ), mysql_error( (MYSQL *)tb->db->Conn ) );
	return NULL;
    }//if ( mysql_real_query( (MYSQL *)tb->db->Conn, tb->Query,strlen (tb->Query) ) )

    if ( ! ( tb->Result = mysql_store_result( (MYSQL *)tb->db->Conn ) ) ) {
	if ( mysql_error( (MYSQL *)tb->db->Conn )[0] ) SER ( "%d=%s", mysql_errno( (MYSQL *)tb->db->Conn ), mysql_error( (MYSQL *)tb->db->Conn ) );
    }//if ( ! ( (MYSQL_RES *)tb->Result = mysql_store_result( (MYSQL *)tb->db->Conn ) ) )

//we have no Result
    if ( ! tb->Result ) return NULL;

//error check
    if ( tb->Error[0] ) return NULL;

//amount of Fields
    tb->Fields  = (long) mysql_num_fields( (MYSQL_RES *)tb->Result );
    D9 ( "tb->Fields=%ld", tb->Fields );

//amount of Records
    tb->Records = (long) mysql_num_rows  ( (MYSQL_RES *)tb->Result );
    D9 ( "tb->Records=%ld", tb->Records );

    return NULL;

}//char *mysql_tbOpen ( _bncTable *tb )


_bncColumn *mysql_tbColumnInsert ( _bncTable *tb, _bncColumn *co, unsigned long ColumnInsertFokus ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
    if ( Error[0] ) return NULL;

MYSQL_FIELD	*field = mysql_fetch_field_direct( (MYSQL_RES *)tb->Result, ColumnInsertFokus );

    //char *org_name;             // Original column name, if an alias
    //char *org_table;            // Org table name, if table was an alias
    //char *db;                   // Database for table
    //char *catalog;              // Catalog for table
    //unsigned long max_length;   // Max width for selected set
    //unsigned int name_length;
    //unsigned int org_name_length;
    //unsigned int table_length;
    //unsigned int org_table_length;
    //unsigned int db_length;
    //unsigned int catalog_length;
    //unsigned int def_length;
    //unsigned int flags;         // Div flags
    //unsigned int charsetnr;     // Character set
    //void *extension;
    D9 ( "field->name     =~%s~", field->name     );//char *name;                 // Name of column
    D9 ( " field->table   =~%s~", field->table    );//char *table;                // Table of column if column was a field
    D9 ( " field->type    =%ld" , field->type     );//enum enum_field_types type; // Type of field. See mysql_com.h for types
    D9 ( " field->length  =%ld" , field->length   );//unsigned long length;       // Width of column (create length)
    D9 ( " field->decimals=%ld" , field->decimals );//unsigned int decimals;      // Number of decimals in field
    D9 ( " field->flags   =0x%x", field->flags    );//unsigned int flags;         // Div flags
    D9 ( " field->def     =~%s~", field->def      );//char *def;                  // Default value (set by mysql_list_fields)	bncSQL-> always NULL
//flag
    if ( field->flags &         NOT_NULL_FLAG ) co->Type |= bn_NOT_NULL        ; // NOT_NULL_FLAG              1 0x000001 // Field cant be NULL
    if ( field->flags &          PRI_KEY_FLAG ) co->Type |= bn_PRI_KEY         ; // PRI_KEY_FLAG               2 0x000002 // Field is part of a primary key
    if ( field->flags &       UNIQUE_KEY_FLAG ) co->Type |= bn_UNIQUE_KEY      ; // UNIQUE_KEY_FLAG            4 0x000004 // Field is part of a unique key
    if ( field->flags &     MULTIPLE_KEY_FLAG ) co->Type |= bn_MULTIPLE_KEY    ; // MULTIPLE_KEY_FLAG          8 0x000008 // Field is part of a key
    if ( field->flags &             BLOB_FLAG ) co->Type |= bn_BLOB            ; // BLOB_FLAG                 16 0x000010 // Field is a blob
    if ( field->flags &         UNSIGNED_FLAG ) co->Type |= bn_UNSIGNED        ; // UNSIGNED_FLAG             32 0x000020 // Field is unsigned
    if ( field->flags &         ZEROFILL_FLAG ) co->Type |= bn_ZEROFILL        ; // ZEROFILL_FLAG             64 0x000040 // Field is zerofill
    if ( field->flags &           BINARY_FLAG ) co->Type |= bn_BINARY          ; // BINARY_FLAG              128 0x000080 // Field is binary  
    if ( field->flags &             ENUM_FLAG ) co->Type |= bn_ENUM            ; // ENUM_FLAG                256 0x000100 // field is an enum
    if ( field->flags &   AUTO_INCREMENT_FLAG ) co->Type |= bn_AUTO_INCREMENT  ; // AUTO_INCREMENT_FLAG      512 0x000200 // field is a autoincrement field
    if ( field->flags &        TIMESTAMP_FLAG ) co->Type |= bn_TIMESTAMP       ; // TIMESTAMP_FLAG          1024 0x000400 // Field is a timestamp
    if ( field->flags &              SET_FLAG ) co->Type |= bn_SET             ; // SET_FLAG                2048 0x000800 // field is a set
    if ( field->flags & NO_DEFAULT_VALUE_FLAG ) co->Type |= bn_NO_DEFAULT_VALUE; // NO_DEFAULT_VALUE_FLAG   4096 0x001000 // Field doesnt have default value
    if ( field->flags &    ON_UPDATE_NOW_FLAG ) co->Type |= bn_ON_UPDATE_NOW   ; // ON_UPDATE_NOW_FLAG      8192 0x002000 // Field is set to NOW on UPDATE
    if ( field->flags &              NUM_FLAG ) co->Type |= bn_NUM             ; // NUM_FLAG               32768 0x004000 // Field is num (for clients)
    if ( field->flags &         PART_KEY_FLAG ) co->Type |= bn_PART_KEY        ; // PART_KEY_FLAG          16384 0x008000 // Intern; Part of some key
    if ( field->flags &            GROUP_FLAG ) co->Type |= bn_GROUP           ; // GROUP_FLAG             32768 0x010000 // Intern: Group field
    if ( field->flags &           UNIQUE_FLAG ) co->Type |= bn_UNIQUE          ; // UNIQUE_FLAG            65536 0x020000 // Intern: Used by sql_yacc
    // ( field->flags &           BINCMP_FLAG ) co->Type |= bn_BINCMP          ; // BINCMP_FLAG           131072 0x040000 // Intern: Used by sql_yacc		 ! @ WIN32

//show tables work around
    if ( strcmp ( tb->Query, "show tables" ) == 0 ) co->Name = strdup ( "name"      );
    else                                            co->Name = strdup ( field->name );

//enum enum_field_types from 5.5.29 mysql_com.h
    D9 ( "MYSQL_TYPE_DECIMAL     = %d", MYSQL_TYPE_DECIMAL     );
    D9 ( "MYSQL_TYPE_TINY        = %d", MYSQL_TYPE_TINY        );
    D9 ( "MYSQL_TYPE_SHORT       = %d", MYSQL_TYPE_SHORT       );
    D9 ( "MYSQL_TYPE_LONG        = %d", MYSQL_TYPE_LONG        );
    D9 ( "MYSQL_TYPE_FLOAT       = %d", MYSQL_TYPE_FLOAT       );
    D9 ( "MYSQL_TYPE_DOUBLE      = %d", MYSQL_TYPE_DOUBLE      );
    D9 ( "MYSQL_TYPE_NULL        = %d", MYSQL_TYPE_NULL        );
    D9 ( "MYSQL_TYPE_TIMESTAMP   = %d", MYSQL_TYPE_TIMESTAMP   );
    D9 ( "MYSQL_TYPE_LONGLONG    = %d", MYSQL_TYPE_LONGLONG    );
    D9 ( "MYSQL_TYPE_INT24       = %d", MYSQL_TYPE_INT24       );
    D9 ( "MYSQL_TYPE_DATE        = %d", MYSQL_TYPE_DATE        );
    D9 ( "MYSQL_TYPE_TIME        = %d", MYSQL_TYPE_TIME        );
    D9 ( "MYSQL_TYPE_DATETIME    = %d", MYSQL_TYPE_DATETIME    );
    D9 ( "MYSQL_TYPE_YEAR        = %d", MYSQL_TYPE_YEAR        );
    D9 ( "MYSQL_TYPE_NEWDATE     = %d", MYSQL_TYPE_NEWDATE     );
    D9 ( "MYSQL_TYPE_VARCHAR     = %d", MYSQL_TYPE_VARCHAR     );
    D9 ( "MYSQL_TYPE_BIT         = %d", MYSQL_TYPE_BIT         );
    D9 ( "MYSQL_TYPE_NEWDECIMAL  = %d", MYSQL_TYPE_NEWDECIMAL  );
    D9 ( "MYSQL_TYPE_ENUM        = %d", MYSQL_TYPE_ENUM        );
    D9 ( "MYSQL_TYPE_SET         = %d", MYSQL_TYPE_SET         );
    D9 ( "MYSQL_TYPE_TINY_BLOB   = %d", MYSQL_TYPE_TINY_BLOB   );
    D9 ( "MYSQL_TYPE_MEDIUM_BLOB = %d", MYSQL_TYPE_MEDIUM_BLOB );
    D9 ( "MYSQL_TYPE_LONG_BLOB   = %d", MYSQL_TYPE_LONG_BLOB   );
    D9 ( "MYSQL_TYPE_BLOB        = %d", MYSQL_TYPE_BLOB        );
    D9 ( "MYSQL_TYPE_VAR_STRING  = %d", MYSQL_TYPE_VAR_STRING  );
    D9 ( "MYSQL_TYPE_STRING      = %d", MYSQL_TYPE_STRING      );
    D9 ( "MYSQL_TYPE_GEOMETRY    = %d", MYSQL_TYPE_GEOMETRY    );

    if ( 1 == 0 ) {}
    //se if ( MYSQL_TYPE_DECIMAL     == field->type ) { co->Type |= ;                                       }//  0 2do
    else if ( MYSQL_TYPE_TINY        == field->type ) { co->Type |= bn_long;                                }//  1 INT1
    else if ( MYSQL_TYPE_SHORT       == field->type ) { co->Type |= bn_long;                                }//  2 INT2, SMALLINT
    else if ( MYSQL_TYPE_LONG        == field->type ) { co->Type |= bn_long;                                }//  3 INT4,INTEGER,INT
    else if ( MYSQL_TYPE_FLOAT       == field->type ) { co->Type |= bn_double;                              }//  4 FLOAT, bug2 decimals on the fly, now Scale = 2, 45.789 = 45.79
    else if ( MYSQL_TYPE_DOUBLE      == field->type ) { co->Type |= bn_double;                              }//  5 DOUBLE PRECISION
    //se if ( MYSQL_TYPE_NULL        == field->type ) { co->Type |= ;                                       }//  6 2do
    else if ( MYSQL_TYPE_TIMESTAMP   == field->type ) { co->Type |= bn_char; *co->Size = field->length;     }//  7 TIMESTAMP
    else if ( MYSQL_TYPE_LONGLONG    == field->type ) { co->Type |= bn_long_long;                           }//  8 BIGINT
    else if ( MYSQL_TYPE_INT24       == field->type ) { co->Type |= bn_long;                                }//  9 INT3
    else if ( MYSQL_TYPE_DATE        == field->type ) { co->Type |= bn_char; *co->Size   = field->length;   }// 10 DATE
    else if ( MYSQL_TYPE_TIME        == field->type ) { co->Type |= bn_char; *co->Size   = field->length;   }// 11 TIME
    else if ( MYSQL_TYPE_DATETIME    == field->type ) { co->Type |= bn_char; *co->Size   = field->length;   }// 12 DATETIME
    else if ( MYSQL_TYPE_YEAR        == field->type ) { co->Type |= bn_long;  co->Format = strdup("%ld");   }// 13 YEAR
    //se if ( MYSQL_TYPE_NEWDATE     == field->type ) { co->Type |= ;                                       }// 14 2do
    //se if ( MYSQL_TYPE_VARCHAR     == field->type ) { co->Type |= ;                                       }// 15 2do
    else if ( MYSQL_TYPE_BIT         == field->type ) { co->Type |= bn_blob;                                }// 16 BIT
    else if ( MYSQL_TYPE_NEWDECIMAL  == field->type ) { co->Type |= bn_double; co->Scale = field->decimals; }//246 DECIMAL(15,7) DECIMAL
    //se if ( MYSQL_TYPE_ENUM        == field->type ) { co->Type |= ;                                       }//247 2do
    //se if ( MYSQL_TYPE_SET         == field->type ) { co->Type |= ;                                       }//248 2do
    else if ( MYSQL_TYPE_TINY_BLOB   == field->type ) { co->Type |= bn_blob;                                }//249 2do test
    else if ( MYSQL_TYPE_MEDIUM_BLOB == field->type ) { co->Type |= bn_blob;                                }//250 from_base64 ( ImageRenderB64BLOB .... 10k
    else if ( MYSQL_TYPE_LONG_BLOB   == field->type ) { co->Type |= bn_blob;                                }//251 2do test
    else if ( MYSQL_TYPE_BLOB        == field->type ) { co->Type |= bn_blob;                                }//252 LONG VARCHAR = 16MB, TEXT = 64K , LONGTEXT = 4GB, LONGBLOB = 4GB
    else if ( MYSQL_TYPE_VAR_STRING  == field->type ) { co->Type |= bn_char; *co->Size = field->length;     }//253 VARCHAR(len),VARBINARY(len)
    else if ( MYSQL_TYPE_STRING      == field->type ) { co->Type |= bn_blob;                                }//254 BINARY(len)
    //se if ( MYSQL_TYPE_GEOMETRY    == field->type ) { co->Type |= ;                                       }//255 2do
    else SER ( "unknown field->type = %ld field->name=~%s~", field->type, field->name );
    D9 ( " co->Type=0x%x", co->Type );
    return co;

}//_bncColumn *mysql_tbColumnInsert ( _bncTable *tb, _bncColumn *co, unsigned long ColumnInsertFokus )


char *mysql_tbClose ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

//char *Error = tb->Error;

    if ( tb->Result ) {
	D9 ( "tb->Name=%s", tb->Name );
    //close table
	mysql_free_result( (MYSQL_RES *)tb->Result );
	tb->Result = NULL;
    }//if ( tb->Result )

    return NULL;

}//char *mysql_tbClose ( _bncTable *tb )


char *mysql_tbColumn ( _bncTable *tb, const char *ColumnName, unsigned char **ret_data, unsigned long *ret_len ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
    if ( Error[0]        ) return NULL;
    if ( ! tb->Records   ) return NULL;
    if ( ! ColumnName    ) SER ( "! ColumnName"    );
    if ( ! ColumnName[0] ) SER ( "! ColumnName[0]" );
    if ( ! ret_data      ) SER ( "! ret_data"      );
    if ( ! ret_len       ) SER ( "! ret_len"       );

    D9 ( "ColumnName=%s", ColumnName );
    D9 ( "ret_data  =%p", ret_data   );
    D9 ( "ret_len   =%p", ret_len    );

//show tables work around
char         tb_FetchColumn_Name[255];
    strcpy ( tb_FetchColumn_Name, ColumnName );
    if ( strcmp ( tb->Query, "show tables" ) == 0 )
	if ( strcmp ( tb_FetchColumn_Name, "name" ) == 0 )
	    sprintf ( tb_FetchColumn_Name, "Tables_in_%s", tb->db->Base );
//show tables work around done

    mysql_data_seek ( (MYSQL_RES *)tb->Result, tb->Fokus -1 );
MYSQL_ROW  cur;
    if ( ( cur = mysql_fetch_row( (MYSQL_RES *)tb->Result ) ) ) {
	int i = 0;
	MYSQL_FIELD	*field;
	mysql_field_seek( (MYSQL_RES *)tb->Result, 0 );
	while ( ( field = mysql_fetch_field( (MYSQL_RES *)tb->Result ) ) ) {
	    D9 ( "field->type=%03ld field->size=%08ld field->name=%s", field->type, field->max_length, field->name );
	    D9 ( " field->flags   =0x%x", field->flags    );
	    if ( strcmp ( tb_FetchColumn_Name, field->name ) == 0 ) {
		*ret_data = (unsigned char *)cur[i];
		*ret_len = field->max_length;
		return NULL;
	    }
	    i++;
	}//while ( ( field = mysql_fetch_field( (MYSQL_RES *)tb->Result ) ) )
    }//if ( cur = mysql_fetch_row( (MYSQL_RES *)tb->Result ) )

    return NULL;

}//char *mysql_tbColumn ( _bncTable *tb, const char *ColumnName, unsigned char **ret_data, unsigned long *ret_len )


char *mysql_tbRecord ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
    if ( Error[0] ) return NULL;

//fetch record, done in tbColumn via Fokus
    return NULL;

}//char *mysql_tbRecord ( _bncTable *tb )


char *mysql_tbSQLBuild ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
    if ( Error[0] ) return NULL;
    if ( ! tb->CreateTableOptions ) tb->CreateTableOptions = strdup ( "ENGINE=InnoDB" );

    return NULL;

}//char *mysql_tbSQLBuild ( _bncTable *tb )


char *mysql_coDEF ( _bncColumn *co ) {
    D9 ( "co=%p", co );

char *Error = co->Error;
    if ( Error[0] ) return NULL;

static char  myDef[512];
    memset ( myDef, 0x00, 512 );
    if      ( bn_long      & co->Type ) { sprintf ( myDef , "%s %10s int4"        , myDef, co->Name            ); }
    else if ( bn_long_long & co->Type ) { sprintf ( myDef , "%s %10s bigint"      , myDef, co->Name            ); }
    else if ( bn_double    & co->Type ) { sprintf ( myDef , "%s %10s float8"      , myDef, co->Name            ); }
    else if ( bn_blob      & co->Type ) { sprintf ( myDef , "%s %10s blob"        , myDef, co->Name            ); }
    else if ( bn_char      & co->Type ) { sprintf ( myDef , "%s %10s varchar(%ld)", myDef, co->Name, *co->Size ); }
    else SER ( "unknown co->Type=0x%08x co->Name=~%s~", co->Type, co->Name );

    if ( co->Type & bn_PRI_KEY        ) sprintf ( myDef , "%s PRIMARY KEY"   , myDef );
    if ( co->Type & bn_AUTO_INCREMENT ) sprintf ( myDef , "%s auto_increment", myDef );

    return myDef;

}//char *mysql_coDEF ( _bncColumn *co )


}//extern "C"
