//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define mysql_BUILTIN

#ifdef mysql_BUILTIN
char *mysql_dbOpen          ( void * );
char *mysql_dbClose         ( void * );
char *mysql_tbOpen          ( void * );
char *mysql_tbColumnInsert  ( void *, _bncColumn *co, unsigned long );
char *mysql_tbClose         ( void * );
char *mysql_tbRecord        ( void * );
char *mysql_tbColumn        ( void *, const char *, unsigned char **, unsigned long * );
char *mysql_tbSQLBuild      ( void * );
char *mysql_coDEF           ( void * );
# define mysql_BUILTIN_DRIVER { \
    if ( strcmp ( Driver, "mysql" ) == 0 ) { \
	if (                 mysql_dbOpen ) { \
	    dbOpen         = mysql_dbOpen        ; \
	    dbClose        = mysql_dbClose       ; \
	    tbOpen         = mysql_tbOpen        ; \
	    tbColumnInsert = mysql_tbColumnInsert; \
	    tbClose        = mysql_tbClose       ; \
	    tbRecord       = mysql_tbRecord      ; \
	    tbColumn       = mysql_tbColumn      ; \
	    tbSQLBuild     = mysql_tbSQLBuild    ; \
	    coDEF          = mysql_coDEF         ; \
	    return Error; \
	} \
    } \
}
# define mysql_BUILTIN_HAVE "mysql;"
#else
# define mysql_BUILTIN_DRIVER
# define mysql_BUILTIN_HAVE
#endif
