//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifndef bnRC4_H
#define bnRC4_H

#ifdef DEBUG
# define bnRC4_DEBUG
#endif

//#define _GLIBCXX_USE_CXX11_ABI 0
#include <string.h>
#include <string>
#include <vector>


class _KeyIdxVal {
public:
    std::string  Key;
    long        *Idx;
    std::string  Val;
    _KeyIdxVal () {
	Key =   "";
	Idx = NULL;
	Val =   "";
    }
};

class _bnRC4 {
private:
    void *StackAdd   ( std::string Key, std::string Val );
    void *StringsAdd ( const char *String );
    std::vector<_KeyIdxVal> *vKeyIdxVal;

public:
    void *Open             ( void );
    void *Close            ( void );
    void *Show             ( void );
    const char *GetVal     ( const char *Key );
    const char *operator[] ( const char *Key );
    char *cString          ( void );

    _bnRC4 () {
	memset ( this, 0x00, sizeof ( _bnRC4 ) );
	ReadENV    = "dbHost;dbBase;dbUser;dbPass;dbDriver;dbTLSCertificate;dbTLSPrivateKey;dbTLSPrivateKeyPass;dbTLSFingerprint00;dbTLSFingerprint01;dbTLSFingerprint02;dbTLSFingerprint03;dbTLSFingerprint04;dbLogLevel;dbLogSyslog;dbLogStdio;dbLogFile";
	vKeyIdxVal = new std::vector<_KeyIdxVal>;
    }

    ~_bnRC4 () {
	Close ();
	delete vKeyIdxVal;
    }

    char        Error[1024];
    int         Argc;
    char      **Argv;
    const char *MustHave;
    const char *String;
    const char *ReadENV;

};

#endif
