//Copyright 2016-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//2do @ open.socket read all rx.data ...
//2do error if dbTLSCertificate,dbTLSPrivateKey file not found
//#define HAVE_SSL
//#define DEBUG
//#define bnSocket_DEBUG
#ifdef HAVE_CONFIG
# include <config.h>
#endif
#include "bnSocket.h"

#include <albus_log.h>
#ifndef bnSocket_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif

#ifdef WIN32
# define read(a,b,c)  recv ( a,       (char *)(b), c, 0 )
# define write(a,b,c) send ( a, (const char *)(b), c, 0 )
#endif


void *_bnSocket::Save ( char *Mode, long Slot, _bnBlob *rx ) {
    D9 ( "this=%p", this );

    if ( ! SaveFile ) return NULL;
    if ( ! SaveLoop ) return NULL;
    if ( ! rx->len  ) return NULL;

    rx->FileWrite ( "%s-%06ld-%p-%06ld-%03ld-%s.bin", SaveFile, getpid (), this, *SaveLoop, Slot, Mode );
    *SaveLoop += 1;

    return NULL;

}//void *_bnSocket::Save ( char *Mode, long Slot, _bnBlob *rx )


void *_bnSocket::Close ( void ) {
    D9 ( "this=%p", this );

//clean up
    for ( unsigned int vs_stack_pos = 0; vs_stack_pos < (*vs_stack).size(); vs_stack_pos++ ) {
	D9 ( "this=%p vs_stack_pos=%03ld", this, vs_stack_pos );
    _bnSocket *soServer = (*vs_stack)[vs_stack_pos];
	if ( ! soServer->fdOpen ) {
	    delete soServer;
	    (*vs_stack).erase ( (*vs_stack).begin() +  vs_stack_pos );
	    break;//2do check (*vs_stack).erase more @ once
	}
    }//for ( int vs_stack_pos = 0; vs_stack_pos < (*vs_stack).size(); vs_stack_pos++ )

    //Error[0] = 0; never clear Error, @ close wait 4 retry

    if ( ! fdClose ) return NULL;
    if ( ! fdOpen  ) return NULL;
    D9 ( "this=%p CloseCB=%p CloseCBArg=%p", this, CloseCB, CloseCBArg );
    if ( CloseCB ) { /*void *dummy = */CloseCB ( this, CloseCBArg ); }

    Write ( NULL );

    D2 ( "this=%p fdSocket=%d close", this, fdSocket );
    fdOpen  = 0;
    fdClose = 1;
    Event   = 0;

    close    ( fdSocket );
#ifndef WIN32
    shutdown ( fdSocket, SHUT_RDWR );//2do @ WIN
#endif
fd_set the_statE = the_state;
    FD_ZERO (                   &the_statE );
    FD_CLR  ( fdSocket, &the_statE );
              fdSocket = 0;

    for ( unsigned int vs_stack_pos = 0; vs_stack_pos < (*vs_stack).size(); vs_stack_pos++ ) {
	D9 ( "this=%p vs_stack_pos=%03ld", this, vs_stack_pos );
    _bnSocket *soServes = (*vs_stack)[vs_stack_pos];
	delete soServes;
    }//for ( int vs_stack_pos = 0; vs_stack_pos < (*vs_stack).size(); vs_stack_pos++ )

    for ( unsigned int vs_stack_pos = 0; vs_stack_pos < (*vs_stack).size(); vs_stack_pos++ ) {
	D9 ( "this=%p vs_stack_pos=%03ld", this, vs_stack_pos );
	(*vs_stack).erase ( (*vs_stack).begin() +  vs_stack_pos );
    }//for ( int vs_stack_pos = 0; vs_stack_pos < (*vs_stack).size(); vs_stack_pos++ )

    D9 ( "this=%p fdSocket=%d close done", this, fdSocket );

    return NULL;

}//void *_bnSocket::Close ( void )


char *_bnSocket::Open ( void ) {
    D9 ( "this=%p", this );

    if ( ! rx ) { rxThis = new _bnBlob; rx = rxThis; }
    if ( ! tx ) { txThis = new _bnBlob; tx = txThis; }

#ifdef WIN32
WSADATA wsaData;
    if ( WSAStartup ( MAKEWORD ( 2, 0 ) ,&wsaData ) == -1 ) SER ( "this=%p WSAStartup", this );
#endif

    if ( Listen ) return OpenServer ();
    else          return OpenClient ();

}//char *_bnSocket::Open ( void )


void *_bnSocket::Read ( void * ) {
    D9 ( "this=%p", this );

//if (   Listen   ) return NULL; //Client
    if (   Error[0] ) return NULL;
    if (   fdClose  ) return NULL;
    if ( ! fdOpen   ) return NULL;

struct timeval timeout;
    timeout.tv_sec  = 0;
    timeout.tv_usec = 0;

fd_set fds_rx = the_state;
fd_set fds_tx = the_state;

    FD_ZERO (           &fds_rx );
    FD_SET  ( fdSocket, &fds_rx );
    FD_ZERO (           &fds_tx );
    FD_SET  ( fdSocket, &fds_tx );
    fd_last = fdSocket;

int    Select = select ( fd_last + 1, &fds_rx, &fds_tx, NULL, &timeout );
    D9 ( "this=%p fdSocket=%03ld Select=%d", this, fdSocket, Select );
    if ( 0 == Select ) return NULL;//no data
    if ( 0  > Select ) {
	//perror ( "select" );
	ER ( "this=%p fdSocket=%03ld 0 > Select=%d", this, fdSocket, Select );
	fdClose = 1;
	Close ();
	//2do reconnect();
	return NULL;
    }

    int fd_rx = fdSocket;
	D9 ( "this=%p fd=%03d, rx=%d, tx=%d", this, fd_rx, FD_ISSET ( fd_rx, &fds_rx ), FD_ISSET ( fd_rx, &fds_tx ) );
	if ( ( rx ) && ( FD_ISSET ( fd_rx, &fds_rx ) ) ) {
	    D9 ( "this=%p fd_rx=%ld fds_rx", this , fd_rx );

	    if ( ( ! rx->len ) && ( fdOpen ) ) {

	    rx_loop:
		D9 ( "this=%p rx->size=%08u rx->len=%08u rx->data=%p", this, rx->size, rx->len, rx->data );
	    unsigned long rxReadSize = 0x7FFF; //default read buffer size
		rx->Malloc ( rxReadSize );
		D9 ( "this=%p rx->size=%08u rx->len=%08u rx->data=%p", this, rx->size, rx->len, rx->data );

		if ( rx->data ) {
#ifdef HAVE_SSL
		    if ( TLS ) {
			D9 ( "this=%p SSL_read", this );
			rxLen = SSL_read ( ssl  , rx->data + rx->len, rxReadSize );
			//perror ("SSL_read");
		    } else {
			D9 ( "this=%p read", this );
			rxLen = read     ( fd_rx              , rx->data + rx->len, rxReadSize );
		    }
#else
			D9 ( "this=%p read", this );
			rxLen = read     ( fd_rx              , rx->data + rx->len, rxReadSize );
#endif
		    D8 ( "this=%p fdSocket=%03d rxLen=%08ld rx->data=~%p~", this, fdSocket, rxLen, rx->data );//D8
		    if ( ! rxLen ) {
			D9 ( "this=%p ! rxLen", this );
			fdClose = 1;
		    }
		    else if ( EOF == (long)rxLen ) {
			D9 ( "this=%p EOF == (long)rxLen", this );
		    }
		    else if ( EOF != (long)rxLen ) {
			rx->len += rxLen;
			if ( 0 != (long)rxLen ) {
			    if ( ! Listen ) {//Client
				FD_ZERO (           &fds_rx );//mv 2 start @ function...
				FD_SET  ( fdSocket, &fds_rx );
				FD_ZERO (           &fds_tx );
				FD_SET  ( fdSocket, &fds_tx );
				fd_last = fdSocket;
				Select = select ( fd_last + 1, &fds_rx, &fds_tx, NULL, &timeout );
				D9 ( "this=%p fdSocket=%03ld Select=%d FD_ISSET ( fd_rx, &fds_rx )=%ld", this, fdSocket, Select, FD_ISSET ( fd_rx, &fds_rx ) );
				if ( FD_ISSET ( fd_rx, &fds_rx ) ) goto rx_loop;
			    }
			}
		    }

		    Event = 1;
		    Save ( (char *)"RX", fd_rx, rx );

		}//if ( rx.data )
		else {//else if ( rx.data )
		    ER ( "this=%p ! rx.data", this );
		}

	    }//if ( ( ! rx.len ) && ( Open ) )

	}//if ( ( rx ) && ( FD_ISSET ( fd_rx, &fds_rx ) ) )

    return NULL;

}//void *_bnSocket::Read ( void * )


void *_bnSocket::Write ( void * ) {
    D9 ( "this=%p", this );

    if (   Error[0] ) return NULL;
    if (   fdClose  ) return NULL;
    if ( ! fdOpen   ) return NULL;

struct timeval timeout;
    timeout.tv_sec  = 0;
    timeout.tv_usec = 0;

fd_set fds_rx = the_state;
fd_set fds_tx = the_state;
	FD_ZERO (           &fds_rx );
	FD_SET  ( fdSocket, &fds_rx );
	FD_ZERO (           &fds_tx );
	FD_SET  ( fdSocket, &fds_tx );
	fd_last = fdSocket;
int    Select = select ( fd_last + 1, &fds_rx, &fds_tx, NULL, &timeout );
    D9 ( "this=%p fdSocket=%03ld Select=%d", this, fdSocket, Select );
    if ( 0 == Select ) return NULL;//no data
    if ( 0  > Select ) {
	//perror ( "select" );
	ER ( "this=%p fdSocket=%03ld 0 > Select=%d", this, fdSocket, Select );
	fdClose = 1;
	Close ();
	//2do reconnect();
	return NULL;
    }

    int fd_rx = fdSocket;
	D9 ( "this=%p fd=%03d, rx=%d, tx=%d", this, fd_rx, FD_ISSET ( fd_rx, &fds_rx ), FD_ISSET ( fd_rx, &fds_tx ) );
	if ( ( tx ) && ( FD_ISSET ( fd_rx, &fds_tx ) ) ) {
	    D9 ( "this=%p fd_rx=%ld fds_tx", this , fd_rx );

	    if ( tx->data ) {
		if ( ( tx->len ) && ( fdOpen ) ) {
		    Event = 1;
		    Save ( (char *)"TX", fd_rx, tx );

		    txLen = 0;
		unsigned long Write_tx_len   = 0x7FFF;//default write buffer size
#ifdef Write_tx_len_SMB
		              Write_tx_len   = 0x01FF;//SMB OK, default write buffer size -> SMB Error EOF == (long)Write_tx_lenRX 2do
#endif
		unsigned long Write_tx_lenRX =      0;
		unsigned long Write2Do       =      0;
		tx_loop:
		    D9 ( "this=%p tx->size=%08u tx->len=%08u tx->data=%p", this, tx->size, tx->len, tx->data );
		    if ( Write_tx_len > tx->len ) Write_tx_len = tx->len;
		    D9 ( "this=%p txLen=%08u Write_tx_len=%08u Write2Do=%08u", this, txLen, Write_tx_len, Write2Do );

		//wait 4 FD_ISSET ( fd_rx, &fds_tx )
		long CommandWhileCount  = 100;
		long CommandWhileUSleep =  10;
		    while ( CommandWhileCount ) {
			D9 ( "this=%p CommandWhileCount=%ld CommandWhileUSleep=%ld", this, CommandWhileCount, CommandWhileUSleep );
			if ( ! Listen ) {//Client
			    FD_ZERO (           &fds_rx );
			    FD_SET  ( fdSocket, &fds_rx );
			    FD_ZERO (           &fds_tx );
			    FD_SET  ( fdSocket, &fds_tx );
			    fd_last = fdSocket;
			}
			Select = select ( fd_last + 1, &fds_rx, &fds_tx, NULL, &timeout );
			D9 ( "this=%p fdSocket=%03ld Select=%d FD_ISSET ( fd_rx, &fds_tx )=%ld", this, fdSocket, Select, FD_ISSET ( fd_rx, &fds_tx ) );
			if ( FD_ISSET ( fd_rx, &fds_tx ) ) break;

			usleep ( CommandWhileUSleep );
			CommandWhileUSleep *=2;
			if ( 999999 < CommandWhileUSleep ) CommandWhileUSleep = 999999;
			CommandWhileCount--;
		    }//while ( CommandWhileCount )
		//wait 4 FD_ISSET ( fd_rx, &fds_tx )

#ifdef HAVE_SSL
		    if ( TLS ) {
			D9 ( "this=%p SSL_write", this );
			Write_tx_lenRX = SSL_write ( ssl  , tx->data + txLen, Write_tx_len );
		    } else {
			D9 ( "this=%p write", this );
			Write_tx_lenRX = write     ( fd_rx, tx->data + txLen, Write_tx_len );
		    }
#else
		    D9 ( "this=%p write", this );
		    Write_tx_lenRX     = write     ( fd_rx, tx->data + txLen, Write_tx_len );
#endif
		    D8 ( "this=%p fdSocket=%03d txLen=%08ld tx->data=~%p~", this, fdSocket, (long)Write_tx_lenRX, tx->data );//D8
		    if ( EOF == (long)Write_tx_lenRX               ) {
			ER ( "this=%p EOF == Write_tx_lenRX=%08X Write_tx_len=%08X", this, Write_tx_lenRX, Write_tx_len );
			fdClose = 1;
		    }
		    else if ( Write_tx_lenRX != Write_tx_len ) {
			ER ( "this=%p Write_tx_lenRX=%08u != Write_tx_len=%08u", this, Write_tx_lenRX, Write_tx_len );
			fdClose = 1;
		    }
		    else {
			txLen += Write_tx_lenRX;
			Write2Do = tx->len - txLen;
			if (                    ! Write2Do ) tx->len = 0;
			else if ( Write_tx_len <= Write2Do ) {                          goto tx_loop; }
			else if ( Write_tx_len  > Write2Do ) { Write_tx_len = Write2Do; goto tx_loop; }
		    }
		}//if ( tx->len )
	    }//if ( tx->data )

	}//if ( ( tx ) && ( FD_ISSET ( fd_rx, &fds_tx ) ) )

    return NULL;

}//void *_bnSocket::Write ( void * )


void *_bnSocket::Accept( void * ) {
    D9 ( "this=%p", this );

    if ( ! Listen ) return NULL; //Client
    if ( ! fdOpen ) return NULL;
    if ( Error[0] ) return NULL;

    D9 ( "this=%p fdSocket=%03d fd_last=%d (*vs_stack).size ()=%03ld", this, fdSocket, fd_last, (*vs_stack).size () );

struct timeval timeout;
    timeout.tv_sec  = 0;
    timeout.tv_usec = 0;

fd_set fds_rx = the_state;
fd_set fds_tx = the_state;
    if ( ! Listen ) {//Client
	FD_ZERO (           &fds_rx );
	FD_SET  ( fdSocket, &fds_rx );
	FD_ZERO (           &fds_tx );
	FD_SET  ( fdSocket, &fds_tx );
	fd_last = fdSocket;
    }//if ( ! Listen )
int    Select = select ( fd_last + 1, &fds_rx, &fds_tx, NULL, &timeout );
    D9 ( "this=%p fdSocket=%03ld Select=%d", this, fdSocket, Select );
    if ( 0 == Select ) return NULL;//no data
    if ( 0  > Select ) {
	//perror ( "select" );
	ER ( "this=%p fdSocket=%03ld 0 > Select=%d", this, fdSocket, Select );
	fdClose = 1;
	Close ();
	//2do reconnect();
	return NULL;
    }

//accept
    if ( Listen ) {//Server
	if ( FD_ISSET ( fdSocket, &fds_rx ) ) {
	struct sockaddr_in sock;
#ifdef WIN32
	int       socklen = sizeof ( struct sockaddr    );
#else
	socklen_t socklen = sizeof ( struct sockaddr_in );
#endif
	int acceptRet = accept ( fdSocket, (struct sockaddr *) &sock, &socklen );

	    if ( acceptRet < 0 ) SER ( "this=%p acceptRet=%d < 0", this, acceptRet );
	//new client
	    FD_SET ( acceptRet, &the_state );
	    if ( acceptRet > fd_last ) {
		fd_last = acceptRet;
	    }//if ( acceptRet > fd_last )

	    Event = 1;

	_bnSocket *fd_stack_new2 = new _bnSocket;
	    (*vs_stack).push_back ( fd_stack_new2 );
	    fd_stack_new2->fdOpen   = 1;
	    fd_stack_new2->fdClose  = 0;
	    fd_stack_new2->SaveLoop = SaveLoop;

#ifdef HAVE_SSL
	    if ( TLS ) {
		if ( ! ssl_ctx ) SER ( "this=%p ! ssl_ctx", this );
		fd_stack_new2->ssl = SSL_new ( ssl_ctx ); //2do perror ("SSL_new");
		if ( ! fd_stack_new2->ssl ) SER ( "this=%p ! ssl", this );
		D9 ( "this=%p ssl=%p", this, fd_stack_new2->ssl );
		SSL_set_fd ( fd_stack_new2->ssl, acceptRet ); //perror ("SSL_set_fd");
		SSL_accept ( fd_stack_new2->ssl ); //perror ("SSL_accept");
	    }//if ( TLS )
#endif

	    fd_stack_new2->fdSocket = acceptRet;
	    if ( SaveFile ) fd_stack_new2->SaveFile = strdup ( SaveFile );

	    D2 ( "this=%p fdSocket=%d fd_stack_new2=%p accept", this, fd_stack_new2->fdSocket, fd_stack_new2 );//D2
	    D2 ( "this=%p accept=%s:%d", this, inet_ntoa(sock.sin_addr), (int)ntohs(sock.sin_port) );//D2

	//CallBack
	    fd_stack_new2->CloseCB     = CloseCB;
	    fd_stack_new2->CloseCBArg  = CloseCBArg;
	    D9 ( "this=%p AcceptCB=%p AcceptCBArg=%p", this, AcceptCB, AcceptCBArg );
	    if ( AcceptCB ) { /*void *dummy = */AcceptCB ( fd_stack_new2, AcceptCBArg ); }

	}//if ( FD_ISSET ( proxy->fdSocket, &fds_rx ) )

    }//if ( Listen )
//accept done

    return NULL;

}//void *_bnSocket::Accept( void * )


char *_bnSocket::Loop ( void ) {
    D9 ( "this=%p", this );

    //2do if ( Now ) {
    //2do 	if ( ( *Now ) & ( RetryNext ) ) {
    //2do 		if ( RetryNext <= *Now ) {
    //2do 			Error[0] = 0;
    //2do 		}
    //2do 	}
    //2do }//if ( Now )

    if ( ( ! fdOpen ) && ( AutoOpen ) ) Open ();
    if   ( ! fdOpen   ) return NULL;
    if (     Error[0] ) return NULL;

    D9 ( "this=%p fdSocket=%03d fd_last=%d (*vs_stack).size ()=%03ld", this, fdSocket, fd_last, (*vs_stack).size () );

    Accept ( NULL );
    Read   ( NULL );
    Write  ( NULL );
    Close  ();

    for ( unsigned int vs_stack_pos = 0; vs_stack_pos < (*vs_stack).size(); vs_stack_pos++ ) {
	D9 ( "this=%p vs_stack_pos=%03ld", this, vs_stack_pos);
	D9 ( "this=%p fdSocket=%d check", this, fdSocket );
    _bnSocket   *soServes  = (*vs_stack)[vs_stack_pos];
	soServes->Read  ( NULL );
	soServes->Write ( NULL );
	soServes->Close ();
    }//for ( int vs_stack_pos = 0; vs_stack_pos < (*vs_stack).size(); vs_stack_pos++ )

    return NULL;

}//char *_bnSocket::Loop ( void )


#ifdef HAVE_SSL
void *_bnSocket::FingerprintCheck ( SSL *ssl ) {
    //return NULL;//bug4debug
    D9 ( "this=%p", this );

char Fingerprint[1024];
    memset ( Fingerprint, 0x00, 1024 );

X509 *certificate = SSL_get_peer_certificate ( ssl );
    if ( ! certificate ) SER ( "this=%p ! certificate", this );

unsigned int n;
unsigned char md[EVP_MAX_MD_SIZE];
const EVP_MD *fdig = EVP_sha256();
	    //fdig = EVP_sha1();
    if ( ! X509_digest ( certificate, fdig, md, &n ) ) {
	X509_free ( certificate );
	SER ( "this=%p ! X509_digest", this );
    }
    X509_free ( certificate );
    D9 ( "this=%p n=%ld", this, n );

    for ( int j = 0; j < (int)n; j++ ) sprintf ( Fingerprint, "%s%02X:", Fingerprint, md[j] );
    if ( ! strlen ( Fingerprint ) ) SER ( "this=%p ! strlen ( Fingerprint )", this );
    Fingerprint[ strlen ( Fingerprint ) - 1 ] = 0;

    D7 ( "this=%p Fingerprint  =~%s~", this, Fingerprint      );//D7
    D9 ( "this=%p Fingerprint00=~%s~", this, TLSFingerprint00 );
    D9 ( "this=%p Fingerprint01=~%s~", this, TLSFingerprint01 );
    D9 ( "this=%p Fingerprint02=~%s~", this, TLSFingerprint02 );
    D9 ( "this=%p Fingerprint03=~%s~", this, TLSFingerprint03 );
    D9 ( "this=%p Fingerprint04=~%s~", this, TLSFingerprint04 );

char FingerprintError = 0;

    if ( TLSFingerprint00 ) {
	if ( strcmp ( Fingerprint, TLSFingerprint00 ) == 0 ) return NULL;
	FingerprintError = 1;
    }

    if ( TLSFingerprint01 ) {
	if ( strcmp ( Fingerprint, TLSFingerprint01 ) == 0 ) return NULL;
	FingerprintError = 1;
    }

    if ( TLSFingerprint02 ) {
	if ( strcmp ( Fingerprint, TLSFingerprint02 ) == 0 ) return NULL;
	FingerprintError = 1;
    }

    if ( TLSFingerprint03 ) {
	if ( strcmp ( Fingerprint, TLSFingerprint03 ) == 0 ) return NULL;
	FingerprintError = 1;
    }

    if ( TLSFingerprint04 ) {
	if ( strcmp ( Fingerprint, TLSFingerprint04 ) == 0 ) return NULL;
	FingerprintError = 1;
    }

    if ( FingerprintError ) SER ( "this=%p fingerprint mismatch", this );
    return NULL;

}//void *_bnSocket::FingerprintCheck ( SSL *ssl )
#endif


char *_bnSocket::OpenClient ( void ) {
    D9 ( "this=%p", this );

#ifndef HAVE_SSL
    if ( TLS ) SER ( "TLS request without HAVE_SSL" );
#endif

    if ( Error[0] ) return NULL;
    if ( fdOpen   ) return NULL;//already open
    fdOpen  = 1;
    fdClose = 0;

    //if ( ! Now  ) SER ( "this=%p ! Now", this  );
    if ( ! Host ) SER ( "this=%p ! Host", this );
    if ( ! Port ) SER ( "this=%p ! Port", this );


    if ( ! hostbyname ) {
	   hostbyname = gethostbyname ( Host );
    }

    if ( ! hostbyname ) {
	SER ( "this=%p ! hostbyname = %s", this, Host );
	//ER ( "this=%p ! hostbyname = %s", this, Host );
	//RetryNext = (*Now) + Retry; //2do
	//return NULL;
    }

    if ( ! Sockaddr ) {
		 Sockaddr = ( struct sockaddr_in *)malloc ( sizeof( struct sockaddr_in ) );
	memset ( Sockaddr, 0, sizeof( struct sockaddr_in ) );
		 Sockaddr->sin_family      = AF_INET;
		 Sockaddr->sin_addr.s_addr = *( (unsigned long *)hostbyname->h_addr_list[0] );
		 Sockaddr->sin_port        = htons ( Port );
    }//if ( ! Sockaddr )
    if ( ! Sockaddr ) SER ( "this=%p ! Sockaddr", this );

	//fdSocket = socket ( AF_INET, SOCK_DGRAM , IPPROTO_UDP );
	  fdSocket = socket ( PF_INET, SOCK_STREAM, IPPROTO_TCP );
	if ( fdSocket < 0 ) SER ( "this=%p fdSocket < 0", this );
	D9 ( "this=%p fdSocket=%d", this, fdSocket );
    long connectRet = connect ( fdSocket, (struct sockaddr *)Sockaddr, sizeof( struct sockaddr_in ) );
	if ( connectRet < 0 ) {
	    //RetryNext = (*Now) + Retry;//2do
	    ER ( "this=%p fdSocket=%d Host=%s:%d offline", this, fdSocket, Host, Port );
	    fdClose = 1;
	    Close ();
	    return NULL;
	}
	else {
	    D2  ( "this=%p fdSocket=%d Host=%s:%d online" , this, fdSocket, Host, Port );//D2
	}

#ifdef HAVE_SSL
	if ( TLS ) {
	    SSL_load_error_strings ();
	    SSL_library_init ();
	    OpenSSL_add_all_algorithms ();
	    ssl_ctx = SSL_CTX_new ( TLSv1_2_client_method () ); //SSLv23_client_method () //2do deprecated @ openssl 1.1.0
	    D9 ( "this=%p ssl_ctx=%p", this, ssl_ctx );

	    if ( ( TLSCertificate ) && ( TLSPrivateKey ) ) {
		if ( ( strlen ( TLSCertificate ) > strlen ( "-----BEGIN CERTIFICATE-----" ) ) && ( strncmp ( TLSCertificate, "-----BEGIN CERTIFICATE-----", strlen ( "-----BEGIN CERTIFICATE-----" ) ) == 0 ) ) {
		    D7 ( "TLSCertificate    = ~%s~", "inline" );
		BIO* bio = BIO_new ( BIO_s_mem () );
		    BIO_write ( bio, TLSCertificate, strlen ( TLSCertificate ) );
		X509 *x509 = PEM_read_bio_X509 ( bio, NULL, NULL, NULL );
		    BIO_free ( bio );
		    SSL_CTX_use_certificate ( ssl_ctx, x509 ); //2do perror
		    X509_free ( x509 );
		}
		else {
		    D7 ( "TLSCertificate    = ~%s~", TLSCertificate     );
		    SSL_CTX_use_certificate_file ( ssl_ctx, TLSCertificate, SSL_FILETYPE_PEM );//2do perror ("SSL_CTX_use_certificate_file");
		}

	    //bug set TLSPrivateKeyPass
		if (
		    ( ( strlen ( TLSPrivateKey ) > strlen ( "-----BEGIN PRIVATE KEY-----"     ) ) && ( strncmp ( TLSPrivateKey, "-----BEGIN PRIVATE KEY-----"    , strlen ( "-----BEGIN PRIVATE KEY-----"     ) ) == 0 ) ) ||
		    ( ( strlen ( TLSPrivateKey ) > strlen ( "-----BEGIN RSA PRIVATE KEY-----" ) ) && ( strncmp ( TLSPrivateKey, "-----BEGIN RSA PRIVATE KEY-----", strlen ( "-----BEGIN RSA PRIVATE KEY-----" ) ) == 0 ) )
		) {
		    D7 ( "TLSPrivateKey     = ~%s~", "inline" );
		BIO* bio = BIO_new ( BIO_s_mem () );
		    BIO_write ( bio, TLSPrivateKey, strlen ( TLSPrivateKey ) );
		EVP_PKEY* pkey = 0;
		    PEM_read_bio_PrivateKey ( bio, &pkey, 0, 0 );
		    BIO_free ( bio );
		RSA* rsa = EVP_PKEY_get1_RSA ( pkey );
		    EVP_PKEY_free ( pkey );
		    SSL_CTX_use_RSAPrivateKey ( ssl_ctx, rsa );//2do error
		    RSA_free ( rsa );
		}
		else {
		    D7 ( "TLSPrivateKey     = ~%s~", TLSPrivateKey      );
		//  D9 ( "TLSPrivateKeyPass = ~%s~", TLSPrivateKeyPass  );//bug4debug
		    SSL_CTX_use_PrivateKey_file ( ssl_ctx, TLSPrivateKey, SSL_FILETYPE_PEM ); //2do perror ("SSL_CTX_use_PrivateKey_file" );
		}

	    }//if ( ( LocalCertificate ) && ( LocalPrivateKey ) )

	    ssl = SSL_new ( ssl_ctx );
	    D9 ( "this=%p ssl=%p", this, ssl );
	    SSL_set_fd  ( ssl, fdSocket );
	    SSL_set_tlsext_host_name ( ssl, Host );
	    SSL_connect ( ssl );
	    D9 ( "this=%p SSL_connect", this );

	    FingerprintCheck ( ssl );
	    if ( Error[0] ) return NULL;

	}//if ( TLS )
#endif

//non-blocking
#ifdef WIN32
u_long iMode = 1;
    ioctlsocket   ( fdSocket, FIONBIO, &iMode );
#else
int flags = fcntl ( fdSocket, F_GETFL, 0 );
            fcntl ( fdSocket, F_SETFL, flags | O_NONBLOCK );
    flags = fcntl ( fdSocket, F_GETFL, 0);
#endif
//non-blocking done

    D9 ( "this=%p fdSocket=%d open", this, fdSocket );

    return NULL;

}//char *_bnSocket::OpenClient ( void )


char *_bnSocket::OpenServer ( void ) {
    D9 ( "this=%p", this );

#ifndef HAVE_SSL
    if ( TLS ) SER ( "TLS request without HAVE_SSL" );
#endif

    if (   Error[0] ) return NULL;
    if (   fdOpen   ) return NULL;//already open
    fdOpen  = 1;
    fdClose = 0;

    if ( ! Host     ) SER ( "this=%p ! Host", this );

      fdSocket = socket ( PF_INET, SOCK_STREAM, IPPROTO_TCP );
    //fdSocket = socket ( PF_INET, SOCK_DGRAM , IPPROTO_UDP );//connection-less
    if ( fdSocket < 0 ) SER ( "this=%p fdSocket = %d < 0", this, fdSocket );

#ifdef HAVE_SSL
    if ( TLS ) {
	if ( ! TLSCertificate ) SER ( "this=%p ! TLSCertificate", this );
	if ( ! TLSPrivateKey  ) SER ( "this=%p ! TLSPrivateKey" , this );
	//bug set TLSPrivateKeyPass
	//bug check TLSCACertificate
	SSL_library_init();//2do perror ("SSL_library_init");
	SSL_load_error_strings();//2do perror ("SSL_load_error_strings");
    const SSL_METHOD *meth = (SSL_METHOD *)TLSv1_2_server_method();//2do perror ("SSLv3_server_method");
	if ( ! meth ) SER ( "this=%p ! meth", this );
	D9 ( "this=%p meth=%p", this, meth );
	ssl_ctx = SSL_CTX_new ( meth );//2do perror ("SSL_CTX_new");
	if ( ! ssl_ctx ) SER ( "this=%p ! ssl_ctx", this );
	D9 ( "this=%p ssl_ctx=%p", this, ssl_ctx );
	SSL_CTX_use_certificate_file ( ssl_ctx, TLSCertificate, SSL_FILETYPE_PEM ); //2do perror ("SSL_CTX_use_certificate_file");
	SSL_CTX_use_PrivateKey_file  ( ssl_ctx, TLSPrivateKey , SSL_FILETYPE_PEM ); //2do perror ("SSL_CTX_use_PrivateKey_file" );
	D9 ( "this=%p SSL_connect", this );
    }//if ( TLS )
#endif

//supress address already in use
char True = 1;
long setsockoptRet = setsockopt ( fdSocket, SOL_SOCKET, SO_REUSEADDR, &True, sizeof ( int ) );
    if ( 0 > setsockoptRet ) SER ( "this=%p 0 > setsockoptRet", this );

    hostbyname = gethostbyname( Host );
    if ( ! hostbyname ) SER ( "this=%p ! hostbyname", this );

    if ( ! Sockaddr ) {
             Sockaddr = ( struct sockaddr_in *)malloc( sizeof( struct sockaddr_in ) );
    }
    memset ( Sockaddr, 0, sizeof( struct sockaddr_in ) );
             Sockaddr->sin_family      = AF_INET;
             Sockaddr->sin_addr.s_addr = *( (unsigned long *)hostbyname->h_addr_list[0] );
             Sockaddr->sin_port        = htons ( Port );

long  bindRet = bind ( fdSocket, (struct sockaddr *)Sockaddr, sizeof ( struct sockaddr_in ) );
    if ( 0 != bindRet ) SER ( "this=%p 0 != bindRet", this );

int listenRet = listen ( fdSocket, Listen );
    if ( 0 > listenRet ) SER ( "this=%p 0 > listenRet", this );

    FD_ZERO (                   &the_state );
    FD_SET  ( fdSocket, &the_state );
    fd_last = fdSocket;

    if ( ! Port ) {
    struct sockaddr_in SockaddrRX;
	memset ( &SockaddrRX, 0, sizeof ( struct sockaddr_in ) );
#ifdef WIN32
    int socklen_t_RX       = sizeof ( struct sockaddr_in );
#else
    socklen_t socklen_t_RX = sizeof ( struct sockaddr_in );
#endif
    int getsocknameRX = getsockname ( fdSocket, (struct sockaddr *)&SockaddrRX, &socklen_t_RX );
	D9 ("getsocknameRX=%d", getsocknameRX );
	//printf ("%s:%d","inet_ntoa(SockaddrRX.sin_addr)",ntohs(SockaddrRX.sin_port));
	Port = ntohs ( SockaddrRX.sin_port );
	D9 ( "this=%p Port=%ld", this, Port );
    }//if ( ! Port )

    if ( ! Port ) SER ( "this=%p ! Port", this );

    D2 ( "this=%p fdSocket=%d open", this, fdSocket );//D2

    return NULL;

}//char *_bnSocket::OpenServer ( void )
