//Copyright 2017 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifdef HAVE_CONFIG
# include <config.h>
#endif
#include <bncSQLProxy.h>

#include <stdio.h>
#include <pthread.h>

#include <albus_log.h>
#ifndef bncSQLProxy_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif


#define    pThreadsMax 50
pthread_t *pThreads = NULL;


void* pThreadWorker( void* pThreadWorkerArg ) {
    D9 ( "call" );
_bncSQLProxy *bncSQLProxy = (_bncSQLProxy *)pThreadWorkerArg;

    if ( ! bncSQLProxy            ) return NULL;
    if ( ! bncSQLProxy->bnForward ) return NULL;

char *Error = bncSQLProxy->Error;

    bncSQLProxy->pThreadExit = 0;
    D7 ( "bncSQLProxy=%p start", bncSQLProxy );//D7
    while ( 1 ) {
	if ( ! bncSQLProxy            ) break;
	if ( ! bncSQLProxy->bnForward ) break;
	D9 ( "bncSQLProxy=%p bncSQLProxy->bnForward=%p loop", bncSQLProxy, bncSQLProxy->bnForward );
	if ( bncSQLProxy->pThreadExit ) {
	    D9 ( "bncSQLProxy->pThreadExit=%d", bncSQLProxy->pThreadExit );
	    break;
	}
	bncSQLProxy->bnForward->Loop ();
	if ( bncSQLProxy->bnForward->Error[0] ) {
	    strcpy ( Error, bncSQLProxy->bnForward->Error );
	    break;
	}
	//usleep (100000);//bug4debug
    }//while ( 1 )

    bncSQLProxy->pThreadExit = 2;
    D7 ( "bncSQLProxy=%p exit", bncSQLProxy );//D7
    pthread_exit ( NULL );
    return NULL;

}//void* pThreadWorker( void* pThreadWorkerArg )


void *_bncSQLProxy::Open ( void ) {
    D9 ( "this=%p", this );

    //albus_log_level  = 9;                            //bug4debug
    //albus_log_stdio  = strdup ( "stderr"          ); //bug4debug
    //albus_log_file   = strdup ( "bncSQLProxy.log" ); //bug4debug

    D2 ( "LocalHost             =%s" , LocalHost );
    D2 ( "LocalPort             =%ld", LocalPort );
    D2 ( "RemoteHost            =%s", RemoteHost             );
    D2 ( "RemoteTLSCertificate  =%s", RemoteTLSCertificate   );
    D2 ( "RemoteTLSPrivateKey   =%s", RemoteTLSPrivateKey    );
    D2 ( "RemoteTLSFingerprint00=%s", RemoteTLSFingerprint00 );
    D2 ( "RemoteTLSFingerprint01=%s", RemoteTLSFingerprint01 );
    D2 ( "RemoteTLSFingerprint02=%s", RemoteTLSFingerprint02 );
    D2 ( "RemoteTLSFingerprint03=%s", RemoteTLSFingerprint03 );
    D2 ( "RemoteTLSFingerprint04=%s", RemoteTLSFingerprint04 );

//global ini
    if ( ! pThreads ) {
	         pThreads = (pthread_t *)malloc( sizeof (pthread_t) * pThreadsMax );
	memset ( pThreads, 0x00,                 sizeof (pthread_t) * pThreadsMax );
    }
    if ( ! pThreads ) SER ( "! pThreads" );

//error check
    if (   Error[0]        ) return NULL;
    if ( ! Driver          ) SER ( "! Driver"        );
    if ( ! Driver[0]       ) SER ( "! Driver[0]"     );
    if ( ! RemoteHost      ) SER ( "! RemoteHost"    );
    if ( ! RemoteHost[0]   ) SER ( "! RemoteHost[0]" );
    if ( ! LocalHost       ) SER ( "! LocalHost"     );
    if ( ! LocalHost[0]    ) SER ( "! LocalHost[0]"  );
    if ( ! Agent           ) SER ( "Agent"           );
    if ( ! Agent[0]        ) SER ( "Agent[0]"        );
    if ( ! AgentVersion    ) SER ( "AgentVersion"    );
    if ( ! AgentVersion[0] ) SER ( "AgentVersion[0]" );

    if ( pThreadIndex ) return NULL;
    for ( unsigned long pThreadsPos = 1; pThreadsPos <= pThreadsMax; pThreadsPos++ ) {
	if ( ! pThreads[pThreadsPos] ) {
	    pThreadIndex = pThreadsPos;
	    pThreads[pThreadIndex] = (pthread_t)1;
	    break;
	}
    }//for ( unsigned long pThreadsPos = 1; pThreadsPos <= pThreadsMax; pThreadsPos++ )
    if ( ! pThreadIndex ) SER ( "! pThreadIndex" );
    D9 ( "pThreadIndex=%ld", pThreadIndex );

    bnForward = new _bnForward;
    D7 ( "bnForward=%p", bnForward );//D7
    bnForward->Set ( 0, "RemoteHost", 0, RemoteHost  );
    bnForward->Set ( 0, "LocalHost" , 0, LocalHost   );
    if ( LocalPort )
	bnForward->LocalPort  =          LocalPort    ;
char pTBuffer[1024];
    sprintf ( pTBuffer, "%s/%s", Agent, AgentVersion );
    bnForward->Set ( 0, "User_Agent"    , 0, pTBuffer             );
    sprintf ( pTBuffer, "%s-%s", Agent, Driver       );
    bnForward->Set ( 0, "ConnectRequest", 0, pTBuffer             );
    bnForward->ProxyConnection = 1;
    if ( RemoteTLSCertificate    ) bnForward->RemoteTLSCertificate    = strdup ( RemoteTLSCertificate    );
    if ( RemoteTLSPrivateKey     ) bnForward->RemoteTLSPrivateKey     = strdup ( RemoteTLSPrivateKey     );
    if ( RemoteTLSPrivateKeyPass ) bnForward->RemoteTLSPrivateKeyPass = strdup ( RemoteTLSPrivateKeyPass );
    if ( RemoteTLSFingerprint00  ) bnForward->RemoteTLSFingerprint00  = strdup ( RemoteTLSFingerprint00  );
    if ( RemoteTLSFingerprint01  ) bnForward->RemoteTLSFingerprint01  = strdup ( RemoteTLSFingerprint01  );
    if ( RemoteTLSFingerprint02  ) bnForward->RemoteTLSFingerprint02  = strdup ( RemoteTLSFingerprint02  );
    if ( RemoteTLSFingerprint03  ) bnForward->RemoteTLSFingerprint03  = strdup ( RemoteTLSFingerprint03  );
    if ( RemoteTLSFingerprint04  ) bnForward->RemoteTLSFingerprint04  = strdup ( RemoteTLSFingerprint04  );

int pthread_createRX = pthread_create ( &pThreads[pThreadIndex], NULL, pThreadWorker, this );
    if ( pthread_createRX ) SER ( "pthread_createRX=%d", pthread_createRX );

time_t        now =  0;
    time   ( &now );
    Timeout = now + 10;//10 sec timeout
    while ( 1 ) {
	D9 ( "bnForward=%p Timeout=%ld now=%ld", bnForward, Timeout, now );
	if ( Error[0] ) return NULL;
	time ( &now );
	if ( ( Timeout ) && ( now > Timeout ) ) SER ( "Timeout" );
	if ( bnForward ) {
	    if ( bnForward->InitDone ) {
		if ( ! LocalPort ) LocalPort = bnForward->LocalPort;
		break;
	    }
	}//if ( bnForward )
    //uSleep
	if ( !  uSleepMin          ) uSleepMin         =   1000;
	if ( !  uSleepMax          ) uSleepMax         = 200000;
	if ( !  uSleep             ) uSleep = uSleepMin;
	if (    uSleep > uSleepMax ) uSleep = uSleepMax;
	//D9 ( "uSleep=%ld", uSleep );
	usleep ( uSleep );
	         uSleep += uSleepMin;
    }//while ( 1 )
    if ( ! LocalPort ) SER ( "! LocalPort" );
    D7 ( "LocalPort=%ld", LocalPort );//D7

    return NULL;

}//void *_bncSQLProxy::Open ( void )


void *_bncSQLProxy::Close ( void ) {
    D9 ( "this=%p", this );

    if ( ! pThreadIndex ) return NULL;

    pThreadExit = 1;

time_t        now =  0;
    time   ( &now );
    Timeout = now + 10;//10 sec timeout
    while ( 1 ) {
	D9 ( "this=%p bnForward=%p Timeout=%ld now=%ld pThreadExit=%ld", this, bnForward, Timeout, now, pThreadExit );
	if ( 2 == pThreadExit ) break;
	time ( &now );
	if ( ( Timeout ) && ( now > Timeout ) ) {
	    pthread_kill ( pThreads[pThreadIndex], SIGTERM );
//#ifdef WIN32
//pthread_cancel ( pThreads[pThreadIndex] );
//#endif
	    PE ( "Timeout" );
	    break;
	}
    //uSleep
	if ( !  uSleepMin          ) uSleepMin         =   1000;
	if ( !  uSleepMax          ) uSleepMax         = 200000;
	if ( !  uSleep             ) uSleep = uSleepMin;
	if (    uSleep > uSleepMax ) uSleep = uSleepMax;
	//D9 ( "uSleep=%ld", uSleep );
	usleep ( uSleep );
	         uSleep += uSleepMin;
    }//while ( 1 )

    pThreads[pThreadIndex] = 0;
             pThreadIndex  = 0;

    bn_delete ( bnForward );

    Error[0] = 0;

    D7 ( "this=%p done", this );//D7

    return NULL;

}//void *_bncSQLProxy::Close ( void )


//#define bncSQLProxy_MAIN
#ifdef  bncSQLProxy_MAIN
#include <string.h>
#include <unistd.h>

#include <albus_log.h>

#include <bncSQLProxy.h>


int main ( void ) {

_bncSQLProxy bncSQLProxy;
    if ( getenv ( "RemoteHost"             ) ) bncSQLProxy.RemoteHost             = strdup ( getenv ( "RemoteHost"             ) );
    if ( getenv ( "RemoteTLS"              ) ) bncSQLProxy.RemoteTLS              = atol   ( getenv ( "RemoteTLS"              ) );
    if ( getenv ( "RemoteTLSCertificate"   ) ) bncSQLProxy.RemoteTLSCertificate   = strdup ( getenv ( "RemoteTLSCertificate"   ) );
    if ( getenv ( "RemoteTLSPrivateKey"    ) ) bncSQLProxy.RemoteTLSPrivateKey    = strdup ( getenv ( "RemoteTLSPrivateKey"    ) );
    if ( getenv ( "RemoteTLSFingerprint00" ) ) bncSQLProxy.RemoteTLSFingerprint00 = strdup ( getenv ( "RemoteTLSFingerprint00" ) );
    if ( getenv ( "RemoteTLSFingerprint01" ) ) bncSQLProxy.RemoteTLSFingerprint01 = strdup ( getenv ( "RemoteTLSFingerprint01" ) );
    if ( getenv ( "RemoteTLSFingerprint02" ) ) bncSQLProxy.RemoteTLSFingerprint02 = strdup ( getenv ( "RemoteTLSFingerprint02" ) );
    if ( getenv ( "RemoteTLSFingerprint03" ) ) bncSQLProxy.RemoteTLSFingerprint03 = strdup ( getenv ( "RemoteTLSFingerprint03" ) );
    if ( getenv ( "RemoteTLSFingerprint04" ) ) bncSQLProxy.RemoteTLSFingerprint04 = strdup ( getenv ( "RemoteTLSFingerprint04" ) );
    if ( getenv ( "LocalHost"              ) ) bncSQLProxy.LocalHost              = strdup ( getenv ( "LocalHost"              ) );
    if ( getenv ( "LocalPort"              ) ) bncSQLProxy.LocalPort              = atol   ( getenv ( "LocalPort"              ) );
    if ( getenv ( "Agent"                  ) ) bncSQLProxy.Agent                  = strdup ( getenv ( "Agent"                  ) );
    if ( getenv ( "AgentVersion"           ) ) bncSQLProxy.AgentVersion           = strdup ( getenv ( "AgentVersion"           ) );
    if ( getenv ( "Driver"                 ) ) bncSQLProxy.Driver                 = strdup ( getenv ( "Driver"                 ) );
//albus_log
    if ( getenv ( "LogLevel"               ) ) albus_log_level                    = atol   ( getenv ( "LogLevel"               ) );
    if ( getenv ( "LogSyslog"              ) ) albus_log_syslog                   = atol   ( getenv ( "LogSyslog"              ) );
    if ( getenv ( "LogStdio"               ) ) albus_log_stdio                    = strdup ( getenv ( "LogStdio"               ) );
    if ( getenv ( "LogFile"                ) ) albus_log_file                     = strdup ( getenv ( "LogFile"                ) );

    bncSQLProxy.Open   ();

    if ( bncSQLProxy.Error[0] ) {
	fprintf ( stderr, "%s\n", bncSQLProxy.Error );
	D9 ( "return" );
	return -1;
    }
    D9 ( "bncSQLProxy OK !!! LocalPort=%ld", bncSQLProxy.LocalPort );

    while ( 1 ) {
	if ( bncSQLProxy.Error[0] ) {
	    fprintf ( stderr, "%s\n", bncSQLProxy.Error );
	    D9 ( "return" );
	    break;
	}
	sleep (3);
	//break; //bug4debug
    }//while ( xLoop-- )

    bncSQLProxy.Close  ();
    D9 ( "return 0" );
    return 0;

}//int main ( void )
#endif
