//Copyright 2016-2017 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <bncsql.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include <albus_log.h>
#ifndef bncsql_DEBUG
# undef  ER
# define ER
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif


long  bncsql_API_Version = bncSQL_API_VERSION;
char  bncsql_Version[]   = "1.0.0";


void *bncSQLShow ( const char *Query );
#ifdef bncSQLRSync_ENABLED
    void *bncSQLCertificateCreate   ( _bncTable *tb );
    void *bncSQLCertificateUpload   ( _bncTable *tb );
    void *bncSQLCertificateDelete   ( _bncTable *tb );
    void *bncSQLCertificateShow     ( _bncTable *tb );
    void *bncSQLApplicationShow     ( _bncTable *tb );
    void *bncSQLApplicationDownload ( _bncTable *tb );
    void *bncSQLApplicationDelete   ( _bncTable *tb );
    void *bncSQLDriverShow          ( _bncTable *tb );
#endif


extern "C" {

char *bncsql_dbOpen ( _bncDataBase *db ) {
    D9 ( "db=%p", db );
    return NULL;
}//char *bncsql_dbOpen ( _bncDataBase *db )


char *bncsql_dbClose ( _bncDataBase *db ) {
    D9 ( "db=%p", db );
    return NULL;
}//char *bncsql_dbClose ( _bncDataBase *db )


char *bncsql_tbOpen ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
    if ( Error[0] ) return NULL;

//error check
    if ( ! tb->Query    ) SER ( "! tb->Query"    );
    if ( ! tb->Query[0] ) SER ( "! tb->Query[0]" );
    if (   tb->Result   ) return NULL;

char *Query = tb->Query;
    D9 ( "tb->Query=~%s~", tb->Query );

    if ( 1 == 0 ) {}
    else if ( strncmp ( Query, "bncsql show", strlen ( "bncsql show" ) ) == 0 ) {
	bncSQLShow ( (const char *)Query );
	return NULL;
    }
    else if ( strncmp ( Query, "bncsql certificate create", strlen ( "bncsql certificate create" ) ) == 0 ) {
#ifdef bncSQLRSync_ENABLED
	bncSQLCertificateCreate ( tb );
#else
	SER ( "bncSQLRSync_DISABLED" );
#endif
    }
    else if ( strncmp ( Query, "bncsql certificate upload", strlen ( "bncsql certificate upload" ) ) == 0 ) {
#ifdef bncSQLRSync_ENABLED
	bncSQLCertificateUpload ( tb );
#else
	SER ( "bncSQLRSync_DISABLED" );
#endif
    }
    else if ( strncmp ( Query, "bncsql certificate delete", strlen ( "bncsql certificate delete" ) ) == 0 ) {
#ifdef bncSQLRSync_ENABLED
	bncSQLCertificateDelete ( tb );
#else
	SER ( "bncSQLRSync_DISABLED" );
#endif
    }
    else if ( strncmp ( Query, "bncsql certificate show", strlen ( "bncsql certificate show" ) ) == 0 ) {
#ifdef bncSQLRSync_ENABLED
	bncSQLCertificateShow ( tb );
#else
	SER ( "bncSQLRSync_DISABLED" );
#endif
    }
    else if ( strncmp ( Query, "bncsql application download", strlen ( "bncsql application download" ) ) == 0 ) {
#ifdef bncSQLRSync_ENABLED
	bncSQLApplicationDownload ( tb );
#else
	SER ( "bncSQLRSync_DISABLED" );
#endif
    }
    else if ( strncmp ( Query, "bncsql application show", strlen ( "bncsql application show" ) ) == 0 ) {
#ifdef bncSQLRSync_ENABLED
	bncSQLApplicationShow ( tb );
#else
	SER ( "bncSQLRSync_DISABLED" );
#endif
    }
    else if ( strncmp ( Query, "bncsql application delete", strlen ( "bncsql application delete" ) ) == 0 ) {
#ifdef bncSQLRSync_ENABLED
	bncSQLApplicationDelete ( tb );
#else
	SER ( "bncSQLRSync_DISABLED" );
#endif
    }
    else if ( strncmp ( Query, "bncsql driver show", strlen ( "bncsql driver show" ) ) == 0 ) {
#ifdef bncSQLRSync_ENABLED
	bncSQLDriverShow ( tb );
#else
	SER ( "bncSQLRSync_DISABLED" );
#endif
    }
    else SER ( "unknown Query=~%s~", Query );

    return NULL;

}//char *bncsql_tbOpen ( _bncTable *tb )


_bncColumn *bncsql_tbColumnInsert ( _bncTable *tb, _bncColumn *co, unsigned long ColumnInsertFokus ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
    if ( Error[0] ) return NULL;

    if ( ! tb->Result ) SER ( "! tb->Result" );

_bncTable **tbs = (_bncTable **)tb->Result;
_bncTable  *tbx = tbs[0];
    if ( ! tbx ) SER ( "! tbx" );
    D9 ( "tbx=%p ColumnInsertFokus=%ld", tbx, ColumnInsertFokus );

_bncColumn *coSrc = (*tbx)[ColumnInsertFokus];
    if ( ! coSrc ) SER ( "! coSrc" );
    D9 ( "coSrc=%p", coSrc );

     co->Name = strdup ( coSrc->Name );
     co->Type =          coSrc->Type  ;
    *co->Size =         *coSrc->Size  ;
    D9 ( " co->Type=0x%x", co->Type );
    return co;

}//_bncColumn *bncsql_tbColumnInsert ( _bncTable *tb, _bncColumn *co, unsigned long ColumnInsertFokus )


char *bncsql_tbClose ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;

    D9 ( "tb->Records=%ld", tb->Records );
    if ( tb->Result ) {
    _bncTable **tbs = (_bncTable **)tb->Result;
	for ( unsigned long RecordsPos = 0; RecordsPos < tb->Records; RecordsPos++ ) {
	_bncTable *tbSrc = tbs[RecordsPos];
	    D9 ( "tbSrc=%p", tbSrc );
	    if ( tbSrc ) delete tbSrc;
	}
	bn_free ( tb->Result );
    }

    return NULL;

}//char *bncsql_tbClose ( _bncTable *tb )


char *bncsql_tbColumn ( _bncTable *tb, const char *ColumnName, unsigned char **ret_data, unsigned long *ret_len ) {
    D9 ( "tb=%p", tb );
    return NULL;
}//char *bncsql_tbColumn ( _bncTable *tb, const char *ColumnName, unsigned char **ret_data, unsigned long *ret_len )


char *bncsql_tbRecord ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
    if ( Error[0] ) return NULL;

    if ( ! tb->Result ) SER ( "! tb->Result" );
    D9 ( "tb->Fokus=%ld", tb->Fokus );
_bncTable **tbs = (_bncTable **)tb->Result;
_bncTable  *tbSrc = tbs[tb->Fokus-1];
    if ( ! tbSrc ) SER ( "! tbSrc" );
    D9 ( "tbSrc=%p", tbSrc );
    tb->Set ( tbSrc );

    return NULL;
}//char *bncsql_tbRecord ( _bncTable *tb )


char *bncsql_tbSQLBuild ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );
    return NULL;
}//char *bncsql_tbSQLBuild ( _bncTable *tb )


char *bncsql_coDEF ( _bncColumn *co ) {
    D9 ( "co=%p", co );
    return NULL;
}//char *bncsql_coDEF ( _bncColumn *co )


}//extern "C"
