//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifndef bnSplitPos_H
#define bnSplitPos_H

#ifdef DEBUG
# define bnSplitPos_DEBUG
#endif

#ifdef __cplusplus
extern "C" {
#endif


typedef struct {
    const char    *Input;
    unsigned long  InputLen;
    char           Delimiter;
    unsigned long  InputPos;
    unsigned long  Beg;
    unsigned long  Len;
    char          *Ignore;
    unsigned long  IgnoreLen;
    char          *Quote;
    void          *Record;
    unsigned long  Records;
    int            DeQuote;
} _bnSplitPos;


_bnSplitPos *bnSplitPosNew  ( const char *Input, long InputLen );
void         bnSplitPosFree ( _bnSplitPos *bnSplitPos );
void         bnSplitPosShow ( _bnSplitPos *bnSplitPos );
_bnSplitPos *bnSplitPosNext ( _bnSplitPos *bnSplitPos );
_bnSplitPos *bnSplitPosIndex ( _bnSplitPos *bnSplitPos );
char        *bnSplitPosGet  ( _bnSplitPos *bnSplitPos, unsigned long Fokus );
void         bnSplitPosTest ( void );


unsigned long IgnoreBeg ( const char *Input, unsigned long InputLen, char *Ignore, unsigned long IgnoreLen, char *Quote, int DeQuote );
unsigned long IgnoreEnd ( const char *Input, unsigned long InputLen, char *Ignore, unsigned long IgnoreLen, char *Quote, int DeQuote );
unsigned long DoubleQuoteDrop ( char *Input, unsigned long InputLen, char *Quote );

#ifdef __cplusplus
}
#endif

#endif
